#ifdef LITTLE_ENDIAN
#define BIG 1
#define LITTLE 0
#else
#define BIG 0
#define LITTLE 1
#endif

int norm(dest,len)
int *dest;
{
    int a;

    while(len>4){
	a= *--dest;
	if(a && a!= -1)return len;
	len-=4;
    }
    return 4;
}

madd1(dest,src,len)
unsigned short *dest,*src;
{
    int carry=0,i,c;

    for(carry=i=0;i<len;i+=4,dest+=2,src+=2){
	c= *(dest+LITTLE)+*(src+LITTLE)+carry;
	*(dest+LITTLE)=c;
	c= *(dest+BIG)+*(src+BIG)+(c>>16);
	*(dest+BIG)=c;
	carry=c>>16;
    }
    if(carry&&!(c&0x8000))
	{*(int *)dest= -1;return(len+4);}
    else if(!carry&&(c&0x8000))
	{*(int *)dest=1;return(len+4);}
    return norm(dest,len);
}

msub1(dest,src,len)
unsigned short *dest,*src;
{
    int carry=0,i,c;

    for(carry=i=0;i<len;i+=4,dest+=2,src+=2){
	c= *(dest+LITTLE)-*(src+LITTLE)+carry;
	*(dest+LITTLE)=c;
	c= *(dest+BIG)-*(src+BIG)+(c>>16);
	*(dest+BIG)=c;
	carry=c>>16;
    }
    if(carry&&!(c&0x8000))
	{*(int *)dest= -1;return(len+4);}
    else if(!carry&&(c&0x8000))
	{*(int *)dest=1;return(len+4);}
    return norm(dest,len);
}

uadd1(dest,code,len)
unsigned short *dest;
{
    int carry=0,i,c;
    unsigned short h=((unsigned int)code>>16),l=(code&0xffff);

    for(carry=i=0;i<len;i+=4,dest+=2,src+=2){
	c= *(dest+LITTLE)+l+carry;
	*(dest+LITTLE)=c;
	c= *(dest+BIG)+h+(c>>16);
	*(dest+BIG)=c;
	carry=c>>16;
    }
    if(carry&&!(c&0x8000))
	{*(int *)dest= -1;return(len+4);}
    else if(!carry&&(c&0x8000))
	{*(int *)dest=1;return(len+4);}
    return norm(dest,len);
}

usub1(dest,code,len)
unsigned short *dest;
{
    int carry=0,i,c;
    unsigned short h=((unsigned int)code>>16),l=(code&0xffff);

    for(carry=i=0;i<len;i+=4,dest+=2,src+=2){
	c= *(dest+LITTLE)-l+carry;
	*(dest+LITTLE)=c;
	c= *(dest+BIG)-h+(c>>16);
	*(dest+BIG)=c;
	carry=c>>16;
    }
    if(carry&&!(c&0x8000))
	{*(int *)dest= -1;return(len+4);}
    else if(!carry&&(c&0x8000))
	{*(int *)dest=1;return(len+4);}
    return norm(dest,len);
}

mmul(*dest,sdlen,*src,dlen)
unsigned short *dest,*src;
{
    int *dptr0,*dptr1,*sptr,dlen=sdlen-dlen;
    int dflag=dest[dlen-1],sflag=src[slen-1];

    for(carry=0,*dptr1=dest+sdlen;dlen>0;){
	for(dptr0=dest+dlen;dptr0!=dest;dptr0--){
	    tmp= *dptr0;*dptr0=tmp1;tmp1=tmp;
	}
	for(tmp=0,dptr=dest+dlen,sptr=src;dptr0<dest+sdlen;dptr0++,sptr++){
	    int al=(*dptr&0xffff),ah=(unsigned int)*dptr>>16;
	    int bl=(*sptr&0xffff),bh=(unsigned int)*sptr>>16;
	    int v0,v1;

	    vl=(v0=al*bl)+tmp1;
	    if(tmp1>=0){
		if(v0<0&&v1>=0)carry=1;
		else carry=0;
	    }
	    else{
		if(v0<0||v1>=0)carry=1;
		else carry=0;
	    }
	    if(carry)
		v0=((unsigned int)v1>>16)|0x10000;
	    else
		v0=(unsigned int)v1>>16;
	    /* v0 must be positive */
	    v0+=(v2=al*bh);
	    if(v2<0&&v0>=0)carry=1; 
	    else carry=0;
	    v4=(v3=ah*bl)+v0;
	    if(v0>=0){
		if(v3<0&&v4>=0)carry++;
	    }
	    else if(v3<0||v4>=0)carry++;
	    *dptr=(v4<<16)|(v1&0xffff);
	    tmp1=ah*bh+((unsigned int)v4>>16)+(carry<<16);
	}
    }
}

umul(dest,len,code)
int *dest;
{
}

mdiv(dest,dlen,src,slen)
int *dest,*src;
{
}

mconv(src,len,dest)
int *src,*dest;
{
}
