/* %W% %D% */

#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>
#include "constdef.h"
#include "defvar.h"

static int gccount=0,gctime=0;
WORD *gheaptop,*gheap,*gheapbottom;
extern int heapsize,lstacksize;
extern int extpercent;

WORD copyobj(a)
char *a;
{
  int t,i,len;
  WORD b,c;

  if((t=tag(a))==FIXNUM)return((WORD)a);
  if(a<(char *)heaptop||a>=(char *)heapbottom){ /* root, UNBOUND */
    return((WORD)a);
  }
  if(t==SYMBOL){
    b=value(a);
    if(b>=gheaptop && b<gheapbottom && tag(b)==SYMBOL)return(b);
    c=(WORD)gheap-(VALUE);
    gheap+=4;
    value(c)=a;
    prname(c)=b;
    value(a)=c;
    return(c);
  }
  else if(t==CONS){
    b=car(a);
    if(b>=gheaptop && b<gheapbottom && tag(b)==CONS)return(b);
    c=(WORD)gheap-(CAR);
    gheap+=2;
    car(c)=a;
    cdr(c)=b;
    car(a)=c;
    return(c);
  }
  c=(WORD)gheap-(TAGPOS);
  switch(t=otag(a)){
  case FLONUM:
    gheap+=FLOSIZE;
    floval(c)=floval(a);
    break;
  case SPECIAL:
    gheap+=SPECSIZE;
    spectop(c)=spectop(a);
    break;
  case CODE:
    len=fixtoi(osize(a));
    gheap+=CODESIZE+(len+1)/2*2;
    osize(c)=itofix(len);
    for(i=2;i<CODESIZE+len;i++)
      *(WORD *)(c+TAGPOS+i*4)= *(WORD *)(a+TAGPOS+i*4);
    break;
  case STREAM:
    gheap+=STREAMSIZE;
    for(i=1;i<STREAMSIZE;i++)
      *(WORD *)(c+TAGPOS+i*4)= *(WORD *)(a+TAGPOS+i*4);
    break;
  case BIGNUM:
  case VECTOR:
    len=fixtoi(osize(a));
    gheap+=BIGSIZE+(len+1)/2*2;
    osize(c)=itofix(len);
    for(i=2;i<BIGSIZE+len;i++)
      *(WORD *)(c+TAGPOS+i*4)= *(WORD *)(a+TAGPOS+i*4);
    break;
  case STRING:
    len=fixtoi(osize(a));
    gheap+=STRINGSIZE+(len+3)/4*4;
    osize(c)=itofix(len);
    for(i=2;i<STRINGSIZE+len;i++)
      *(WORD *)(c+TAGPOS+i*4)= *(WORD *)(a+TAGPOS+i*4);
    break;
  default:
    if((WORD)t>=gheaptop && (WORD)t<gheapbottom && tag((WORD)t)==OTHERS)
      return((WORD)t);
    for(i=0;tag3(t=otag(a))!=OTAGS;i++,a-=4)
      if((WORD)t>=gheaptop && (WORD)t<gheapbottom && tag((WORD)t)==OTHERS)
	return(reference((WORD)t,i-VECSIZE));
    if(t!=VECTOR){fprintf(stderr,"gc error in reference\n");abort();}
    len=fixtoi(osize(a));
    gheap+=BIGSIZE+(len+1)/2*2;
    osize(c)=itofix(len);
    for(i=2;i<CODESIZE+len;i++)
      *(WORD *)(c+TAGPOS+i*4)= *(WORD *)(a+TAGPOS+i*4);
  }
  otag(a)=c;
  otag(c)=t;
  return(c);
}

print_obj(obj,fp)
WORD obj,*fp;
{
  if(obj==UNBOUND){printf("*UNBOUND*\n");fflush(stdout);return;}
  if(tag(obj)==0){printf("%d\n",fixtoi(obj));fflush(stdout);return;}
  if(obj<heaptop || obj>heapbottom){printf("!!!!! %x\n",obj);fflush(stdout);return;}
  l(0)=obj;
  print_f(1,fp-1);
  flush_f(0,fp);
}


gc(fp)
WORD *fp;
{
  struct tms buffer;
  time_t utime;
  int *ptr,len,i;
  struct lispenv *envptr;
  extern int lstacksize,cstacksize,bstacksize;

  times(&buffer);
  utime=buffer.tms_utime;
  if(heaptop==allheaptop)
    gheap=gheaptop=allheaptop+heapsize/sizeof(int);
  else gheap=gheaptop=allheaptop;
  gheapbottom=gheaptop+heapsize/sizeof(int);
  for(i=0;i<sizeof(root)/sizeof(WORD);i++)
    root[i]=(WORD)copyobj(root[i]);
  for(ptr=(int *)bstack;ptr<(int *)bstackbottom;ptr++)
    *ptr=(int)copyobj(*ptr);
  for(ptr=(int *)cstack;ptr<(int *)cstackbottom;ptr++)
    *ptr=(int)copyobj(*ptr);
  for(envptr=estack;envptr<estackbottom;envptr++)
    envptr->envobj=(WORD)copyobj(envptr->envobj);
/* modified by tanaka 1989/3/15 */
  for(ptr= (int *)lstackbottom-1;ptr>=(int *)fp;ptr--)
    *ptr=(int)copyobj(*ptr);
  sweep();
  heaptop=gheaptop;heapbottom=gheapbottom;heap=gheap;
  if(extpercent>=0 && ((char *)heapbottom-(char *)heaptop)/100*extpercent
     <(char *)heap-(char *)heaptop) /* extend gc size */
    extheap(fp);
  gccount++;
  times(&buffer);
  gctime+=buffer.tms_utime-utime;
}

extheap(fp)
{
  WORD *newheaptop;
  int *ptr,len,i;
  struct lispenv *envptr;

  heapsize*=2;
  if((newheaptop=(WORD *)malloc(heapsize*2))==NULL){
    fprintf(stderr,"Unable to realloc heap area\n");
    exit(1);
  }
  gheap=gheaptop=newheaptop+heapsize/sizeof(WORD);
  gheapbottom=gheaptop+heapsize/sizeof(WORD);
  for(i=0;i<sizeof(root)/sizeof(WORD);i++)
    root[i]=(WORD)copyobj(root[i]);
  for(ptr=(int *)bstack;ptr<(int *)bstackbottom;ptr++)
    *ptr=(int)copyobj(*ptr);
  for(ptr=(int *)cstack;ptr<(int *)cstackbottom;ptr++)
    *ptr=(int)copyobj(*ptr);
  for(envptr=estack;envptr<estackbottom;envptr++)
    envptr->envobj=(WORD)copyobj(envptr->envobj);
/* modified by tanaka 1989/3/15 */
  for(ptr= (int *)lstackbottom-1;ptr>=(int *)fp;ptr--)
    *ptr=(int)copyobj(*ptr);
  sweep();
  heaptop=gheaptop;heapbottom=gheapbottom;heap=gheap;
  free(allheaptop);
  allheaptop=newheaptop;
 }

sweep()
{
  int *sweepptr,t,i,len;
  WORD a;

  for(sweepptr=gheaptop;sweepptr<gheap;){
    if((t=tag(a= *(WORD *)sweepptr))==CONS){
      *(WORD *)sweepptr=copyobj(*(WORD *)(sweepptr+1));
      *(WORD *)(sweepptr+1)=copyobj(cdr(a));
      sweepptr+=2;
      continue;
    }
    else if(t==SYMBOL){
      *(WORD *)sweepptr=copyobj(*(WORD *)(sweepptr+1));
      *(WORD *)(sweepptr+1)=copyobj(prname(a));
      *(WORD *)(sweepptr+2)=copyobj(plist(a));
      *(WORD *)(sweepptr+3)=copyobj(definition(a));
      sweepptr+=4;
      continue;
    }
    switch((int)(a)){
    case FLONUM:
      sweepptr+=FLOSIZE;
      break;
    case BIGNUM:
      sweepptr+=BIGSIZE+(fixtoi(*(sweepptr+1))+1)/2*2;
      break;
    case STRING:
      sweepptr+=STRINGSIZE+(fixtoi(*(sweepptr+1))+3)/4*4;
      break;
    case SPECIAL:
      sweepptr+=SPECSIZE;
      break;
    case VECTOR:
      len= fixtoi(*(WORD *)(sweepptr+1));
      for(i=VECSIZE;i<VECSIZE+len;i++)
	*(sweepptr+i)=copyobj(*(sweepptr+i));
      sweepptr+=VECSIZE+(len+1)/2*2;
      break;
    case STREAM:
      *(sweepptr+(FILNAME+3)/4)=copyobj(*(sweepptr+(FILNAME+3)/4));
      sweepptr+=STREAMSIZE;
      break;
    case CODE:
      len=fixtoi(*(WORD *)(sweepptr+1));
      *(sweepptr+(FUNCNAME+3)/4)=copyobj(*(sweepptr+(FUNCNAME+3)/4));
      for(i=0;i<len;i++)
	*(sweepptr+(LITERAL+3)/4+i)=copyobj(*(sweepptr+(LITERAL+3)/4+i));
      sweepptr+=CODESIZE+(len+1)/2*2;
      break;
    default:
      fprintf(stderr,"Internal gc error\n");exit(1);
    }
  }
}

WORD gc_f(na,fp)
WORD fp;
{
  if(na!=0)parerr();
  gc(fp);
  return(nil);
}

WORD gccount_f(na,fp)
WORD *fp;
{
  if(na!=0)parerr();
  return(itofix(gccount));
}

WORD gctime_f(na,fp)
WORD *fp;
{
  if(na!=0)parerr();
  return(itofix(gctime));
}

WORD heapsize_f(na,fp)
WORD *fp;
{
  if(na!=0)parerr();
  return(itofix(heapsize));
}

WORD heapfree_f(na,fp)
WORD *fp;
{
  int i,*ptr;

  return(itofix((char *)heapbottom-(char *)heap));
}

WORD symsize_f(na,fp)
WORD *fp;
{
  if(na!=0)parerr();
  return(itofix(0));
}

WORD symfree_f(na)
{
  return(itofix(0));
}
WORD fixsize_f(na)
{
  if(na!=0)parerr();
  return(itofix(0));
}

WORD fixfree_f(na)
{
  if(na!=0)parerr();
  return(itofix(0));
}

WORD stacksize_f(na)
{
  if(na!=0)parerr();
  return(itofix(lstacksize));
}

WORD stack_used_f(na,fp)
WORD *fp;
{
  if(na!=0)parerr();
  return(itofix((int)(fp-((char *)lstack-(char *)lstacktop))));
}
WORD othersize_f(na)
{
  if(na!=0)parerr();
  return(itofix(0));
}

WORD otherfree_f(na)
{
  if(na!=0)parerr();
  return(itofix(0));
}

WORD stack_bottom_f(na)
{
  return(itofix(0));
}
WORD stack_top_f(na)
{
  return(itofix(0));
}
WORD stack_base_f(na)
{
  return(itofix(0));
}


