;	@(#)compsys.lap	1.3	12/15/87

(declare (labeltab extention entry pc quotes qvecadr object changes oldlabel pass) special)

(defun pre-process (l)
  (lets ((vec (mapvector (kernel-entry-vector)
			 (function
			  (lambda (n) `(,(logshift n -16) ,(logand 65535 n))))))
	 (ent '((return . 0) (eval . 1) (equal . 2) (alcons . 3) (alxcons . 4) 
		(funcala . 5) (funcalsy . 6) (funcalcd . 7) (ubverr . 8) 
		(typerr . 9) (indexerr . 10) (udferr . 11) (paramerr . 12) 
		(indexerrna . 13) (indexerrd . 14) (indexerrdw . 15) 
		(ubverrd . 16) (typerrd . 17) (allist . 18) (alvector . 19) 
		(alblock . 20) (al2list . 21) (catch_1 . 22))))
	`(,(first l)
	   ,(second l)
	   (,(mapcan (first (third l))
		     (function
		      (lambda (x) (copy (vref vec (cdr (assq x ent))))))) . 
	     ,(second (third l)))
	   ,(/* 4
		(/+ 3
		    (length (first (third l)))
		    (length (second (third l)))
		    (length (sixth l))))
	   ,(fourth l)
	   ,(mapcan (fifth l)
		    (function
		     (lambda (x)
			     (cond ((fixp x) `(,x))
				   (t (copy (vref vec (cdr (assq x ent)))))))))
	   ,(sixth l))))

(defun post-process (l)
  (mapcan l
	  (function
	   (lambda (x)
		   (match x
			  ((('ifatom) r dest)
			   `(((cmp . 2) ,r lt) ((bgt) (label ,dest))))
			  ((('iflist) r dest)
			   `(((cmp . 2) ,r lt) ((ble) (label ,dest))))
			  ((('ifatomerr) r dest)
			   (lets ((lab (gensym "post")))
				 `(((cmp . 2) ,r lt)
				   ((ble) (label ,lab))
				   ((jmp) (sys ,dest))
				   ,lab)))
			  ((('iflisterr) r dest)
			   (lets ((lab (gensym "post")))
				 `(((cmp . 2) ,r lt)
				   ((bgt) (label ,lab))
				   ((jmp) (sys ,dest))
				   ,lab)))
			  (x `(,x)))))))

(defun c:laperr (op) (format "*** assembler error *** /s/n" op) (break))

(defun printall(l)
	(lets ((x))
	(do ((x l (cdr x)))
		((atom x))
		(print (car x)))))
(defun c:oldlap (l)
  (lets ((labeltab) (entry) (p1 (lap:pass-one (cddr l))))
	`(,(first l) 
	   ,(second l) 
	   ,(lap:entry (second p1)) 
	   ,(/- (first p1) 4) . 
	   ,(lap:pass-two (third p1) (/+ 20 (/* 4 (length (second  p1))))))))))
(defun c:lap(l)
	(lets ((labeltab)(entry)(oldlabel)(p1)(p)(oldsize 10)(newsize 0))
		(do ((pass 0 (1+ pass)))
			((or (> pass 10)(and (> pass 1)(equal oldlabel labeltab))))
			(setq entry nil)
			(setq oldlabel labeltab)
			(setq labeltab nil)
			(setq p1 (lap:pass-one (cddr l)))
			(setq oldsize newsize)
			(setq newsize (first p1))
			(setq p pass)
		)
		(cond ((> p 10)(setq pass 0)(c:oldlap l))
			(t
	`(,(first l) 
	   ,(second l) 
	   ,(lap:entry (second p1)) 
	   ,(/- (first p1) 4) . 
	   ,(lap:pass-two (third p1) (/+ 20 (/* 4 (length (second  p1))))))))))

(defun lap:n (regs (n 0))
  (mapc regs (function (lambda (x) (putprop x n 'lap:n) (incr n 1)))))

(defun lap:pass-one (l)
  (lets ((pc 4) (entry) (object))
	(mapc l
	      (function
	       (lambda (x)
		       (cond ((atom x) (push `(,x . ,pc) labeltab))
			     (t (lets ((extention))
				      (funcall (get (caar x) 'lap:pass1)
					       (cdr x)
					       (caar x)
					       (cdar x))
				      (and extention
					   (setq object
						 (nconc extention object)
						 ))))))))
	`(,pc ,(nreverse entry) ,(nreverse object))))

(defun lap:push (x) (push x object) (incr pc 2))

(defun lap:push-e (x) (push x extention) (incr pc 2))

(defun lap:regnum (reg) (cdr (get reg 'lap:regnum)))

(defun lap:opmode (mnem size) (nth size (get mnem 'lap:opmode)))

(defun lap:ea (operand size)
  (match operand
	 ((x disp reg size) (lap:an@drs x disp reg size))
	 (('const x) (lap:#xx x size))
	 (('fix x) (lap:#fxx x size))
	 (('tag x) (lap:#txx x size))
	 (('quote x) (lap:an@d 'cb `',operand))
	 (('defof x) (lap:an@d 'cb `'(getd ',x)))
	 (('label x) (lap:an@d 'pc `(,x . ,(/+ 2 pc))))
	 (('sys x) (lap:xxl x))
	 (('code x) (lap:an@d 'cb operand))
	 ((x '/+) (get x 'lap:an@+))
	 ((x '/-) (get x 'lap:an@-))
	 ((x disp) (lap:an@d x disp))
	 ((x) (get x 'lap:an@))
	 (x (get x 'lap:an))))

(defun lap:an@drs (x disp reg size)
  (lap:push-e (lap:extention reg disp size))
  (get x 'lap:an@drs))

(defun lap:#xx (x size) (lap:immed x size) '(2496 . 60))

(defun lap:#fxx (x size) (lap:fimmed x size) '(2496 . 60))

(defun lap:#txx (x size) (lap:timmed x size) '(2496 . 60))

(defun lap:an@d (x disp) (lap:push-e disp) (get x 'lap:an@d))

(defun lap:xxl (x) (lap:push-e x) (incr pc 2) '(960 . 57))

(defun lap:extention (reg disp size)
  (logor (logshift
	  (cond ((lap:dreg? reg) (get reg 'lap:n))
		((lap:areg? reg) (/+ 8 (get reg 'lap:n))))
	  12)
	 (logshift (/1- size) 11)
	 disp))

(defun lap:immed (x size)
  (cond ((fixp x)
	 (cond ((= size 2)
		(lap:push-e
		 (cond ((/0> x)
			(logand (logor (logshift x -16) 61440) 65535))
		       (t (logand (logshift x -16) 65535))))
		(lap:push-e (logand x 65535)))
	       (t (lap:push-e x))))
	(t (incr pc 2) (lap:push-e x))))

(defun lap:fimmed (x size)
  (and (fixp x)
       (= size 2)
       (lap:push-e (logor 49152 (logand (logshift x -14) 16383)))
       (lap:push-e (logand (* 4 x) 65535))))

(defun lap:timmed (x size)
  (and (memq x '(0 1 3 4 5 6))
       (= size 2)
       (lap:push-e %8000)
       (lap:push-e (logshift x 12))))

(defun lap:dreg? (reg)
  (and (symbolp reg) (not (get reg 'lap:an@)) (get reg 'lap:n)))

(defun lap:areg? (reg)
  (and (symbolp reg) (get reg 'lap:an@) (get reg 'lap:n)))

(defun def:lap (mode prop regs n)
  (mapc regs
	(function
	 (lambda (x)
		 (putprop x
			  `(,(logor (logshift n 9) (logshift mode 6)) . 
			     ,(logor (logshift mode 3) n))
			  prop)
		 (incr n 1)))))

(defun lap:type1 (args mnem size)
  (match args
	 ((ea reg)
	  (and (null size) (setq size 1))
	  (lap:gen3
	   mnem
	   (logshift (or (funcall (get mnem 'lap:reg?) reg) (c:laperr mnem)) 9)
	   (lap:opmode mnem size)
	   (cdr (lap:ea ea size))))
	 (x (c:laperr mnem))))

(defun lap:type2 (args mnem size)
  (match args
	 ((reg ea)
	  (lap:gen3
	   mnem
	   (logshift (or (lap:dreg? reg) (c:laperr mnem)) 9)
	   (logshift (/+ 4 size) 6)
	   (cdr (lap:ea ea size))))
	 (x (c:laperr mnem))))

(defun lap:type3 (args mnem size)
  (match args
	 ((('const immed) ea)
	  (lap:immed immed size)
	  (lap:gen2 mnem (logshift size 6) (cdr (lap:ea ea size))))
	 ((('fix immed) ea)
	  (lap:fimmed immed size)
	  (lap:gen2 mnem (logshift size 6) (cdr (lap:ea ea size))))
	 ((('tag immed) ea)
	  (lap:timmed immed size)
	  (lap:gen2 mnem (logshift size 6) (cdr (lap:ea ea size))))
	 (x (c:laperr mnem))))
  
(defun lap:type4 (args mnem size)
  (match args
	 ((ea)
	  (and (null size) (setq size 0))
	  (lap:gen2 mnem (lap:opmode mnem size) (cdr (lap:ea ea size))))
	 (x (c:laperr mnem))))

(defun lap:type5 (args mnem size)
  (match args
	 ((src dst)
	  (lap:gen3
	   mnem
	   (nth size '(4096 12288 8192))
	   (cdr (lap:ea src size))
	   (car (lap:ea dst size))))
	 (x (c:laperr mnem))))

(defun lap:type6 (args mnem size)
  (match args
	 ((('const immed) ea)
	  (lap:gen3
	   mnem
	   (logshift
	    (cond ((= immed 8) 0)
		  ((and (/0< immed) (< immed 8)) immed)
		  (t (c:laperr mnem)))
	    9)
	   (lap:opmode mnem size)
	   (cdr (lap:ea ea size))))
	 (x (c:laperr mnem))))

(defun lap:type7 (args mnem size)
  (and (null size) (setq size 0))
  (and (atom args) (c:laperr mnem))
  (lap:gen2
   mnem
   (lap:opmode mnem size)
   (or (funcall (get mnem 'lap:reg?) (car args)) (c:laperr mnem)))
  (match args
	 ((reg))
	 ((reg ('const displacement))
	  (or (eq mnem 'link) (c:laperr mnem))
	  (lap:push displacement))
	 (x (c:laperr mnem))))

(defun lap:type8 (args mnem size)
  (match args
	 ((('label lab))
	  (cond ((zerop pass)(lap:gen0 mnem)(lap:push `(,lab . ,pc)))
		(t (lets ((offset (/- (cdr (assq lab oldlabel)) pc 2)))
			 (cond 
			  ((or(> offset 127)(< offset -128))
     			   (lap:gen0 mnem)(lap:push `(,lab . ,pc)))
			  (t
   ;  			   (lap:gen0 mnem)(lap:push `(,lab . ,pc))))))))
				   (lap:gen1 mnem (logand offset 255))))))))
	 (x (c:laperr mnem))))

(defun lap:type9 (args mnem size)
  (match args
	 ((('const n) reg)
	  (lap:gen4
	   mnem
	   (logshift
	    (cond ((= n 8) 0) ((and (/0< n) (< n 8)) n) (t (c:laperr mnem)))
	    9)
	   (lap:opmode mnem size)
	   (get mnem 'lap:shift)
	   (or (lap:dreg? reg) (c:laperr mnem))))
	 ((reg1 reg2)
	  (lap:gen4
	   mnem
	   (or (lap:dreg? reg1) (c:laperr mnem))
	   (lap:opmode mnem size)
	   (/+ 32 (get mnem 'lap:shift))
	   (or (lap:dreg? reg2) (c:laperr mnem))))
	 (x (c:laperr mnem))))

(defun lap:type10 (args mnem size)
  (match args
	 ((('const n) reg)
	  (lap:gen2
	   mnem
	   (logshift (or (lap:dreg? reg) (c:laperr mnem)) 9)
	   (logand n 255)))
	 (x (c:laperr mnem))))

(defun lap:entry (e)
  (do ((l e (cdr l)) (x) (y))
      ((atom l) `(,x ,(nreverse y)))
      (cond ((atom (car l)) (push (car l) x))
	    (t (push (cdr (assq (second (car l)) labeltab)) y)))))

(defun lap:pass-two (l qvecadr)
  (lets ((quotes))
	`(,(mapcan l
		   (function
		    (lambda (x)
			    (cond ((atom x) `(,x))
				  ((eq (car x) 'label)
				   `(,(cdr (assq (second x) labeltab))))
				  ((eq (car x) 'quote) (lap:quote (second x)))
				  ((eq (car x) 'code) (lap:code (second x)))
				  (t (lap:label (car x) (cdr x)))))))
	   ,(nreverse quotes))))

(defun lap:quote (x)
  (lets ((l (member x quotes)))
	`(,(/+ qvecadr -4 (* 4 (length (or l (push x quotes))))))))

(defun lap:code (x)
  `(,(/+ qvecadr
	 -4
	 (* 4
	    (length (push `(load-code (pre-process ',(c:lap x))) quotes))))))

(defun lap:label (lab pc) `(,(/- (cdr (assq lab labeltab)) pc)))

(defun lap:init nil
  (lap:n '(dww dw l na lt ht sl n))
  (lap:n '(ww w x cb d a sb sp))
  (def:lap 1 'lap:an '(ww w x cb d a sb sp) 0)
  (def:lap 2 'lap:an@ '(ww w x cb d a sb sp) 0)
  (def:lap 3 'lap:an@+ '(ww w x cb d a sb sp) 0)
  (def:lap 4 'lap:an@- '(ww w x cb d a sb sp) 0)
  (def:lap 5 'lap:an@d '(ww w x cb d a sb sp) 0)
  (def:lap 6 'lap:an@drs '(ww w x cb d a sb sp) 0)
  (def:lap 0 'lap:an '(dww dw l na lt ht sl n) 0)
  (def:lap 7 'lap:an@d '(pc) 2)
  (def:lap 7 'lap:an@drs '(pc) 3)
  (mapc '((add1 13 (0 1 2) lap:dreg?)
	  (adda 13 (0 3 7) lap:areg?)
	  (and1 12 (0 1 2) lap:dreg?)
	  (cmp 11 (0 1 2) lap:dreg?)
	  (cmpa 11 (0 3 7) lap:areg?)
	  (divs 8 (7 7 7) lap:dreg?)
	  (divu 8 (3 3 3) lap:dreg?)
	  (lea 4 (7 7 7) lap:areg?)
	  (muls 12 (7 7 7) lap:dreg?)
	  (mulu 12 (3 3 3) lap:dreg?)
	  (or1 8 (0 1 2) lap:dreg?)
	  (sub1 9 (0 1 2) lap:dreg?)
	  (suba 9 (0 3 7) lap:areg?))
	(function
	 (lambda (x)
		 (lets ((mnem (first x)))
		       (putprop mnem (logshift (second x) 12) 'lap:opcode)
		       (putprop mnem
				(mapcar (third x)
					(function (lambda (y) (logshift y 6))))
				'lap:opmode)
		       (putprop mnem (fourth x) 'lap:reg?)
		       (putprop mnem 'lap:type1 'lap:pass1)))))
  (mapc '((add2 . 13) (and2 . 12) (eor . 11) (or2 . 8) (sub2 . 9))
	(function
	 (lambda (x)
		 (putprop (car x) (logshift (cdr x) 12) 'lap:opcode)
		 (putprop (car x) 'lap:type2 'lap:pass1))))
  (mapc '((addi . 6) (andi . 2) (cmpi . 12) (eori . 10) (ori . 0) 
	  (subi . 4))
	(function
	 (lambda (x)
		 (putprop (car x) (logshift (cdr x) 8) 'lap:opcode)
		 (putprop (car x) 'lap:type3 'lap:pass1))))
  (mapc '((clr 4 2 (0 1 2))
	  (jmp 4 14 (3 3 3))
	  (jsr 4 14 (2 2 2))
	  (neg 4 4 (0 1 2))
	  (not 4 6 (0 1 2))
	  (pea 4 8 (1 1 1))
	  (tst 4 10 (0 1 2)))
	(function
	 (lambda (x)
		 (lets ((mnem (car x)))
		       (putprop mnem
				(logor (logshift (second x) 12)
				       (logshift (third x) 8))
				'lap:opcode)
		       (putprop mnem
				(mapcar (fourth x)
					(function (lambda (y) (logshift y 6))))
				'lap:opmode)
		       (putprop mnem 'lap:type4 'lap:pass1)))))
  (mapc '(move movea)
	(function
	 (lambda (x)
		 (putprop x 0 'lap:opcode)
		 (putprop x 'lap:type5 'lap:pass1))))
  (mapc '((addq 5 (0 1 2)) (subq 5 (4 5 6)))
	(function
	 (lambda (x)
		 (lets ((mnem (first x)))
		       (putprop mnem (logshift (second x) 12) 'lap:opcode)
		       (putprop mnem
				(mapcar (third x)
					(function (lambda (y) (logshift y 6))))
				'lap:opmode)
		       (putprop mnem 'lap:type6 'lap:pass1)))))
  (mapc '((ext (4 8 0 0) (0 2 3) lap:dreg?)
	  (swap (4 8 4 0) (0 0 0) lap:dreg?)
	  (link (4 14 5 0) (0 0 0) lap:areg?)
	  (unlk (4 14 5 8) (0 0 0) lap:areg?))
	(function
	 (lambda (x)
		 (lets ((mnem (first x)) (a (second x)))
		       (putprop mnem
				(logor (logshift (first a) 12)
				       (logshift (second a) 8)
				       (logshift (third a) 4)
				       (fourth a))
				'lap:opcode)
		       (putprop mnem
				(mapcar (third x)
					(function (lambda (y) (logshift y 6))))
				'lap:opmode)
		       (putprop mnem (fourth x) 'lap:reg?)
		       (putprop mnem 'lap:type7 'lap:pass1)))))
  (mapc '((bra . 0) (bcc . 4) (bcs . 5) (beq . 7) (bge . 12) (bgt . 14) 
	  (bhi . 2) (ble . 15) (bls . 3) (blt . 13) (bmi . 11) (bne . 6) 
	  (bpl . 10) (bvc . 8) (bvs . 9))
	(function
	 (lambda (x)
		 (putprop (car x)
			  (logor (logshift 6 12) (logshift (cdr x) 8))
			  'lap:opcode)
		 (putprop (car x) 'lap:type8 'lap:pass1))))
  (mapc '((asl 14 0 (4 5 6))
	  (asr 14 0 (0 1 2))
	  (lsl 14 1 (4 5 6))
	  (lsr 14 1 (0 1 2)))
	(function
	 (lambda (x)
		 (lets ((mnem (first x)))
		       (putprop mnem (logshift (second x) 12) 'lap:opcode)
		       (putprop mnem (logshift (third x) 3) 'lap:shift)
		       (putprop mnem
				(mapcar (fourth x)
					(function (lambda (y) (logshift y 6))))
				'lap:opmode)
		       (putprop mnem 'lap:type9 'lap:pass1)))))
  (mapc '((moveq . 7))
	(function
	 (lambda (x)
		 (putprop (car x) (logshift (cdr x) 12) 'lap:opcode)
		 (putprop (car x) 'lap:type10 'lap:pass1)))))

(defprop entry
  (lambda (args mnem size) (push (car args) entry))
  lap:pass1)

(defun lap:gen4 (mnem a b c d)
  (lap:push (logor (get mnem 'lap:opcode) a b c d)))

(defun lap:gen3 (mnem a b c) (lap:push (logor (get mnem 'lap:opcode) a b c)))

(defun lap:gen2 (mnem a b) (lap:push (logor (get mnem 'lap:opcode) a b)))

(defun lap:gen1 (mnem a) (lap:push (logor (get mnem 'lap:opcode) a)))

(defun lap:gen0 (mnem) (lap:push (get mnem 'lap:opcode)))

(defun lap:index (x) (match x ((adr base lap:index) lap:index) (t 0)))

(defun lap:based (b adr) (logor (logshift b 12) adr))

(defun low-level-optimize (codes)
  (do ((changes nil nil))
      ((progn (lap:eliminate (cdr codes) (lap:shortcut (cdr codes)))
	      (not changes))
       (lap:final codes))))

(defmacro del-second (x) `(progn (setl (cdr ,x) (cddr ,x)) (setq changes t)))

(defmacro del-first (x) `(progn (setl (car ,x) (cadr ,x)) (del-second ,x)))

(defun lap:eliminate (codes referred)
  (do ((l codes (cdr l)))
      ((null l))
      (do nil
	  ((or (consp (car l)) (memq (car l) referred)))
	  (del-first l)
	  (setq changes t))
      (or (atom (car l))
	  (selectq (caaar l)
		   ((bra bcc bcs beq bge bgt bhi ble
			 bls blt bmi bne bpl bvc bvs)
		    (lets ((lab (second (second (first l)))) (b (caaar l)))
			  (cond ((and (eq b 'bra) (cdr l) (consp (second l)))
				 (setl (cdr l) (some (cdr l) (function atom)))
				 (setq changes t))
				((and (cdr l)
				      (consp (second l))
				      (eq (caar (second l)) 'bra)
				      (cddr l)
				      (eq lab (third l)))
				 (del-first l)
				 (setl (caar l)
				       `(,(cdr (assq b 
						     '((bgt . ble) (ble . bgt)
						       (blt . bge) (bge . blt)
						       (bne . beq) (beq . bne) 
						       (bmi . bpl) (bpl . bmi)
						       (bhi . bls) (bls . bhi)
						       (bvs . bvc) (bvc . bvs) 
						       (bcc . bcs) (bcs . bcc)
						       )))))
				 (setq lab nil)
				 (setq changes t)))
			  (and (cdr l) (eq lab (second l)) (del-first l))))
		   ((jmp)
		    (cond ((and (cdr l) (consp (second l)))
			   (setl (cdr l) (some (cdr l) (function atom)))
			   (setq changes t))))))))

(defun lap:shortcut (codes)
  (do ((l codes (cdr l)) (referred))
      ((null l) referred)
      (or (atom (car l))
	  (selectq (caaar l)
		   ((entry lea pea)
		    (match (first l)
			   (((inst) ('label lab) . rest)
			    (lets ((dest (memq lab codes)))
				  (do nil
				      ((consp (second dest)))
				      (pop dest)
				      (setq changes t))
				  (setl (second (second (first l)))
					(first dest))
				  (push (first dest) referred)))))
		   ((bra bcc bcs beq bge bgt bhi ble
			 bls blt bmi bne bpl bvc bvs)
		    (lets ((lab (second (second (first l)))) 
			   (dest (memq lab codes)))
			  (do nil ((consp (second dest)))
			      (pop dest) (setq changes t))
			  (match (second dest)
				 ((('bra) ('label lab1))
				  (cond ((neq lab lab1)
					 (setl (second (second (first l))) lab1)
					 (push lab1 referred)
					 (setq changes t))
					(t (push lab referred))))
				 ((('jmp) ('sys sysaddr))
				  (cond ((eq (caaar l) 'bra)
					 (setl (first l) (second dest))
					 (setq changes t))
					(t (setl (second (second (first l)))
						 (first dest))
					   (push (first dest) referred))))
				 (x (setl (second (second (car l)))
					  (first dest))
				    (push (first dest) referred)))))))))
	
(defun lap:final (codes) codes)

(lap:init)

(defmacro make-code (fn args . body)
  `(pre-process (c:lap '(,fn ,(length args) . ,body))))
