(putd 'defun '(macro lambda (_x) (list 'putd (list 'quote (car _x))
	(list 'quote (cons 'lambda (cdr _x)))))) 
(putd 'macro '(macro lambda (_x) (list 'putd (list 'quote (car _x))
	(list 'quote (cons 'macro (cons 'lambda (cdr _x)))))))
(defun mapcan (_c _fn)(cond ((null _c)nil)(t(nconc(funcall _fn(car _c))(mapcan(cdr _c)_fn)))))
(defun mapcon (_c _fn)(cond ((null _c)nil)(t(nconc(funcall _fn _c)(mapcon(cdr _c)_fn)))))
(defun expt (x y)
  (cond ((and (integerp y)(plusp y))
	 (do ((i 0 (add1 i))
	      (val 1))
	     ((>= i y)val)
	     (setq val (times val x))))
	(t (^$ (cond ((integerp x)(float x))(t x))
	       (cond ((integerp y)(float y))(t y))))))
;(putd 'bugged-quotient (getd 'quotient))
;(defun tail-cut(l)
;  (cond ((atom (cdr l))nil)
;	(t(cons (car l)(tail-cut(cdr l))))))
;(defun tail(l)
;  (cond ((atom (cdr l))(car l))
;	(t(tail(cdr l)))))
;(macro quotient(l)
;       (cond ((= (length l) 2)(cons 'bugged-quotient l))
;	     (t (list 'bugged-quotient (cons 'quotient (tail-cut l))
;		      (tail l)))))
;(readmacro 27 (function readcode))
(macro defmacro (l)
   (list 'macro
         (car l)
         '(@)
         (list 'match
               '@
               (cdr l)
               (list '@
                     (list 'funcall
                           'err:argument-type
                           '@
                           (list 'quote (car l)))))))
(defmacro declare (l type)
   (or (memq type
             '(special redefine fix-result fix-value nogc
	       string-result fixnum vector string lppeval))
       (funcall err:argument-type type 'declare))
   (list 'lets
         (list (list 'type (list 'quote type)))
         (list 'mapc
               (list 'quote l)
               '(function (lambda (x) (putprop x t type))))))
(declare (system_lib_path lispfile print-result package-obvector) special)
(declare (print-result package-obvector) special)
(defun exfile (lispfile (print-result) (readtable default-readtable) 
               (macrotable default-macrotable))
   (catch 'exfile (exfile* lispfile)))
(defun exfile* (lispfile)
   (lets ((standard-input (inopen (stream (alloc lispfile)))) 
          (err:end-of-file (function (lambda (stg (dum)) (throw 'exfile)))))
    (cond (print-result (loop (print (eval (read)))))
          (t (loop (eval (read)))))))
(putd 'include-file (getd 'exfile))
(defmacro package-load (lispfile . externals)
   (list 'package-load* lispfile (list 'quote externals)))
(defun package-load* (lispfile externals)
   (lets ((package-obvector (vector 1023)) 
          (intern (function
                   (lambda (str)
                    (car (or (intern-soft str obvector)
                             (ncons (intern str package-obvector))))))))
    (exfile lispfile)))
(defun oblist ((v obvector))
   (do ((i 0 (/1+ i))
        (result nil (append (vref v i) result))
        (l (vector-length v)))
       ((eq i l) result)))
(defun remob (x (v obvector))
   (lets ((n (\ (hash x) (vector-length v))))
    (vset v n (delq x (vref v n)))
    nil))
(defun convert-back-quote (x)
   (cond ((null x) nil)
         ((atom x) (list 'quote x))
         ((eq (car x) '/,) (cdr x))
         (t (do ((const t)
                 (l x (cdr l))
                 (res nil
                      (cond (const (match (convert-back-quote (car l))
                                      ('nil (cons 'nil res))
                                      (('quote x) (cons x res))
                                      (x (setq const nil) 
                                       (cons x 
                                        (mapcar res 
                                         (function 
                                          (lambda (x) (list 'quote x))))))))
                            (t (cons (convert-back-quote (car l)) res)))))
                ((or (atom l) (eq (car l) '/,))
                 (cond ((null l)
                        (cond (const (list 'quote (nreverse res)))
                              (t (cons 'list (nreverse res)))))
                       (const (match (convert-back-quote l)
                                 (('quote x)
                                  (list 'quote (nconc (nreverse res) x)))
                                 (x (do 
                                     ((l res (cdr l))
                                      (res x 
                                       (list 'cons (list 'quote (car l)) 
                                        res)))
                                     ((null l) res)))))
                       (t (do ((l res (cdr l))
                               (res (convert-back-quote l)
                                    (cond ((and (consp res) 
                                            (eq (car res) 'quote) 
                                            (null (cddr res)) (consp (car l)) 
                                            (eq (caar l) 'quote) 
                                            (null (cddr (car l))))
                                           (list 'quote 
                                            (cons (second (car l)) 
                                             (second res))))
                                          (t (list 'cons (car l) res)))))
                              ((null l) res)))))))))
(defun set-backquote-character (char)
   (readmacro
      (character char)
      (function (lambda nil (convert-back-quote (read))))))
(set-backquote-character "`")
(defun set-unquote-character (char)
   (readmacro (character char) (function (lambda nil (cons '/, (read))))))
(set-unquote-character ",")
(macro format (l)
   (lets ((str (car l)) (args (cdr l)) (leng (string-length str)) (obj))
    (do ((n 0 (/+ m 2))
         (m (string-search-char "/" str 0)
            (string-search-char "/" str (/+ m 2))))
        ((null m)
         (cons 'progn
               (nreverse
                  (cons 'nil
                        (cond ((eq n leng) obj)
                              (t (cons (list 'princ (substring str n)) 
                                  obj)))))))
        (or (eq m n) (push (list 'princ (substring str n m)) obj))
        (push (selectq (getchar str (/1+ m))
                 ((n N) '(terpri))
                 ((s S)
                  (list 'prin1
                        (cond ((atom args)
                               (funcall err:number-of-arguments nil 'format))
                              (t (pop args)))))
                 ((c C)
                  (list 'princ
                        (cond ((atom args)
                               (funcall err:number-of-arguments nil 'format))
                              (t (pop args)))))
                 ((i g I G)
                  (list 'prind
                        (cond ((atom args)
                               (funcall err:number-of-arguments nil 'format))
                              (t (pop args)))))
                 (// '(princ "/"))
                 ((t T)
                  (list 'tab
                        (cond ((atom args)
                               (funcall err:number-of-arguments nil 'format))
                              (t (pop args)))))
                 ((b B) (list 'tyo (pop args)))
                 (t (funcall err:argument-type (getchar str n) 'format)
                    (exit)))
              obj))))
(macro do (l)
   (list 'let
         (mapcar (car l)
            (function
             (lambda (x) (list (first x) (and (listp (cdr x)) (second x))))))
         (list 'loop
               (cons 'and
                     (and (listp (cadr l))
                          (list (caadr l) (cons 'exit (cdadr l)))))
               (cons 'progn (cddr l))
               (cons 'setq
                     (mapcan (car l)
                        (function
                         (lambda (x)
                          (and (listp (cdr x))
                               (listp (cddr x))
                               (list (first x) (third x))))))))))
(defmacro defprop (x y z)
   (list 'putprop (list 'quote x) (list 'quote y) (list 'quote z)))
(defmacro defnprop (x y z)
   (list 'putprop (list 'quote x) (list 'function y) (list 'quote z)))
(defmacro incr (x n) (list 'setq x (list '/+ x n)))
(defmacro decr (x n) (list 'setq x (list '/- x n)))
(defmacro setl (where what)
   (match where
      ((fn x)
       (selectq fn
          ((car caar cadr caaar caadr cadar caddr first second third fourth)
           (list 'rplaca
                 (list (cdr (assq fn
                               '((car . cr) (caar . car) (cadr . cdr) 
                                 (caaar . caar) (caadr . cadr) 
                                 (cadar . cdar) (caddr . cddr) (first . cr) 
                                 (second . cdr) (third . cddr) 
                                 (fourth . cdddr))))
                       x)
                 what))
          ((cdr cddr cdar cdddr cddar cdadr cdaar)
           (list 'rplacd
                 (list (cdr (assq fn
                               '((cdr . cr) (cddr . cdr) (cdar . car) 
                                 (cdddr . cddr) (cddar . cdar) 
                                 (cdadr . cadr) (cdaar . caar))))
                       x)
                 what))
          ((deref plist getd)
           (list (cdr (assq fn
                         '((deref . setref) (plist . setplist) 
                           (getd . putd))))
                 x
                 what))
          (t (cond ((and (symbolp fn)
                         (definedp fn)
                         (consp (getd fn))
                         (eq (car (getd fn)) 'macro))
                    (list 'setl (funcall (cdr (getd fn)) (list x)) what))
                   (t (funcall err:argument-type where 'setl))))))
      ((fn x y)
       (selectq fn
          ((vref sref bref)
           (list (cdr (assq fn
                         '((vref . vset) (sref . sset) (bref . bset))))
                 x
                 y
                 what))
          (nth (list 'rplaca (list 'nthcdr x y) what))
          (t (cond ((and (symbolp fn)
                         (definedp fn)
                         (consp (getd fn))
                         (eq (car (getd fn)) 'macro))
                    (list 'setl (funcall (cdr (getd fn)) (list x y)) what))
                   (t (funcall err:argument-type where 'setl))))))
      ((fn . args) 
       (cond ((and (symbolp fn)
                   (definedp fn)
                   (consp (getd fn))
                   (eq (car (getd fn)) 'macro))
              (list 'setl (funcall (cdr (getd fn)) args) what))
             (t (funcall err:argument-type where 'setl))))
      (where (cond ((symbolp where) (list 'setq where what))
                   (t (funcall err:argument-type where 'setl))))))
(setq usebq nil)
(macro exm (l) (list (cdr (getd (first l))) (list 'quote (cdr l))))
(macro macro-expand (l) (list (cdr (getd (first l))) (list 'quote (cdr l))))
(putd 're (getd 'string-match))
(defun filter (l pred)
   (mapcan l
      (function (lambda (x) (cond ((funcall pred x) (list x)) (t nil))))))
(defun symbol-lessp (x y) (string-lessp (pname x) (pname y)))
(defun symbol-greaterp (x y) (string-lessp (pname y) (pname x)))
(defun hex-image-char (n) (sref "0123456789abcdef" n))
(defun hex-image (n)
   (lets ((s (make-string 6 "0")))
    (do ((i 5 (/- i 1)) (n n (logshift n -4)))
        ((eq i -1) s)
        (sset s i (hex-image-char (logand n 15))))))
(defun hex-value (s)
   (lets ((x 0) (n (string-length s)))
    (do ((i 0 (/1+ i)))
        ((eq i n) x)
        (setq x (logor (logshift x 4)
                       (string-search-char
                          (sref lower-case (sref s i))
                          "0123456789abcdef"))))))
(defun string-hex-image (str)
   (lets ((size (string-length str)) (result (make-string (* 2 size) 0)))
    (do ((i 0 (add1 i)) (j 0 (add1 j)))
        ((= i size) result)
        (sset result j (hex-image-char (quotient (sref str i) 16)))
        (sset result
              (incr j 1)
              (hex-image-char (remainder (sref str i) 16))))))
(defun string-hex-value (s)
   (lets ((n (string-length s)) (r (make-string (// n 2) 0)))
    (do ((i 0 (/+ i 2)) (j 0 (/1+ j)))
        ((eq i n) r)
        (sset r j (hex-value (substring s i (/+ i 2)))))))
(defun string-change (text pat1 pat2 (count (string-length text)))
   (lets ((s 0) (result) (i) (pat1-length (string-length pat1)))
    (loop (cond ((<= count 0) (push (substring text s) result) (exit)))
          (setq i (string-search pat1 text s))
          (cond ((null i) (push (substring text s) result) (exit)))
          (push (substring text s i) result)
          (push pat2 result)
          (setq s (/+ i pat1-length))
          (setq count (/1- count)))
    (eval (cons 'string-append (reverse result)))))
(defun string-trim (str (chars " "))
   (string-right-trim (string-left-trim str chars) chars))
(defun string-both-trim (str (chars " "))
   (string-right-trim (string-left-trim str chars) chars))
(defun string-right-trim (str (chars " "))
   (lets ((i (string-search-not-char chars (setq str (string-reverse str)))))
    (cond ((null i) (string-append ""))
          (t (string-reverse (substring str i))))))
(defun string-left-trim (str (chars " "))
   (lets ((i (string-search-not-char chars (setq str str))))
    (cond ((null i) (string-append "")) (t (substring str i)))))
(defun left-adjust (s n (pud " "))
   (substring (string-append s (make-string n pud)) 0 n))
(defun right-adjust (s n (pud " "))
   (lets ((str (string-append (make-string n pud) s)) 
          (size (string-length str)))
    (substring str (/- size n))))
(defun number-image (n)
   (lets ((sign (cond ((>= n 0) "") (t (setq n (/- n)) "-"))) (result))
    (loop (push (string (/+ (character "0") (\ n 10))) result)
          (cond ((/0= (setq n (// n 10)))
                 (exit (apply 'string-append (cons sign result))))))))
(defun number-value (s)
   (lets ((size (string-length s)) (x 0) (i 0))
    (loop (and (eq i size) (exit x))
	  (or (<= (character "0") (sref s i) (character "9"))
	      (exit))
          (setq x (/+ (* x 10) (/- (sref s i) (character "0"))))
          (incr i 1))))
(defun push-toplevel (fn)
   (putprop 'toplevel (cons toplevel (get 'toplevel ':toplevel)) ':toplevel)
   (setq toplevel fn))
(defun pop-toplevel nil
   (lets ((s (get 'toplevel ':toplevel)))
    (cond (s (setq toplevel (first s)) (putprop 'toplevel (cdr s) ':toplevel))
          (t (setq toplevel 'utilisp)))
    toplevel))
(remob ':toplevel)
(defmacro autoload (funcs file load . externals)
   (cons 'progn
         (mapcar funcs
            (function
             (lambda (func)
              (list 'macro
                    func
                    '(l)
                    (cons load (cons file externals))
                    (list 'cons (list 'quote func) 'l)))))))
(defun prind (x (leng (linelength)) (asblock) (plev) (plen))
   (package-load (string-append system_lib_path "lisplib/prind.l")
		  *prind printable *block)
   (funcall 'prind x leng asblock plev plen))
(putd 'grind (getd 'prind))
(defmacro pp (fn)
   (and (definedp fn)
        (lets ((f (getd fn)))
         (cond ((consp f)
                (match f
                   (('lambda . x) `(prind '(defun ,fn . ,x)))
                   (('macro 'lambda ('@) ('match '@ x . y))
                    `(prind '(defmacro ,fn . ,x)))
                   (('macro 'lambda . x) `(prind '(macro ,fn . ,x)))
		   (('macro . x) `(and (codep ',x) (prind ',f)))))
               ((codep f) `(prind ',f))))))
(defun rind ((prompt prompt))
   (package-load (string-append system_lib_path "lisplib/rind.l"))
   (funcall 'rind prompt))
(defun sort (table <)
   (package-load (string-append system_lib_path "lisplib/sort.l"))
   (funcall 'sort table <))
(defun whatis (fname)
   (package-load (string-append system_lib_path "lisplib/whatis.l")
		  previous-definition function-description)
   (funcall 'whatis fname))
(autoload (trace trace-when untrace)
	(string-append system_lib_path "lisplib/trace.l") package-load)
(autoload (program-load)
	  (string-append system_lib_path "lisplib/progload.l") exfile)
(autoload (compile compfile revert reset-compilation-flags c:lambda make-code)
   (string-append system_lib_path "lispcomp/comprc")
   package-load
   typecheck ubvcheck indexcheck udfcheck low-level-optimize
   previous-definition compiled-code function-description)
(autoload (ed edf edv edp) (string-append system_lib_path "lisplib/newed.l")
			 exfile)
(autoload (edit) (string-append system_lib_path "lisplib/amuse.l") exfile)
(autoload (stingy) (string-append system_lib_path "lisplib/stingy.l")
			package-load)
(autoload (prolog) (string-append system_lib_path "lisplib/pkr.l") exfile)
(defun call (str) (systemcall str))
(defun cd ((str (getenv "HOME"))) (systemchdir str))
(defun getenv (str) (systemgetenv str))
(defun userid () (getenv "USER"))
(defun date-time nil
   (lets ((vec (localtime (vector 9))))
    (string-append
       (date-time* (vref vec 5))
       (date-time* (/1+ (vref vec 4)))
       (date-time* (vref vec 3))
       (date-time* (vref vec 2))
       (date-time* (vref vec 1))
       (date-time* (vref vec 0)))))
(defun date-time* (n)
   (lets ((result (make-string 2)))
    (sset result 0 (/+ (character "0") (\ (// n 10) 10)))
    (sset result 1 (/+ (character "0") (\ n 10)))
    result))
(defun make-character-conversion-table (from to disp)
   (do ((table (make-string 256)) (i 0 (/1+ i)))
       ((>= i 256) table)
       (sset table i (cond ((>= to i from) (/+ i disp)) (t i)))))
(setq lower-case
   (make-character-conversion-table
      (character "A")
      (character "Z")
      (/- (character "a") (character "A"))))
(setq upper-case
   (make-character-conversion-table
      (character "a")
      (character "z")
      (/- (character "A") (character "a"))))
(defmacro defconst (var val)
  `(progn (putprop ',var ,val 'constant) (setq ,var ,val)))

; Process command options of utilisp.
;	Before entering this file (/usr/lib/lispsys.l),
;	the following options are processed by the interpreter.
;
;	-h (heapsize)
;	-f (compiled code area size)
(setq argv (argv))

; Option "-n" : don't execute .lisprc
(or (member "-n" argv)
    (lets ((err:open-close (function (lambda (x (w)) (throw 'lisprc)))) 
           (lisprc (string-append (getenv "HOME") "/.utilisprc")))
     (catch 'lisprc (exfile lisprc))))

; Option "-F" : execute one initial file
(lets ((f (member "-F" argv)))
 (and f
      (cdr f)
      (lets ((err:open-close (function (lambda (x (w)) (throw 'lisprc)))) 
             (file (cadr f)))
       (catch 'lisprc (exfile file)))))

