#include <a.out.h>
#include <stab.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <malloc.h>
#include <stdio.h>

loadcode(filename)
char *filename;
{
	int fd,i;
	struct exec fhead;
	struct reloc_info_sparc *trrel,*drrel;
	struct nlist *sym;
	struct stat sbuf;
	char *str;

	if(stat(filename,&sbuf)<0){
		fprintf(stderr,"%s error in stat\n",filename);
		exit(1);
	}
	if((fd=open(filename,O_RDONLY))<0){
		fprintf(stderr,"%s is not found\n",filename);
		exit(1);
	}
	read(fd,&fhead,sizeof(fhead));
#ifdef notdef
	printf("a_dynamic=%d\n",fhead.a_dynamic);
	printf("a_toolversion=%d\n",fhead.a_toolversion);
	printf("a_machtype=%d\n",fhead.a_machtype);
	printf("a_magic=%d\n",fhead.a_magic);
	printf("a_text=%d %x\n",fhead.a_text,N_TXTOFF(fhead));
	printf("a_data=%d %x\n",fhead.a_data,N_DATOFF(fhead));
	printf("a_bss=%d\n",fhead.a_bss);
	printf("a_syms=%d %x\n",fhead.a_syms,N_SYMOFF(fhead));
	printf("a_entry=%d\n",fhead.a_entry);
	printf("a_trsize=%d %x\n",fhead.a_trsize,N_TRELOFF(fhead));
	printf("a_drsize=%d %x\n",fhead.a_drsize,N_DRELOFF(fhead));
#endif
	if((trrel=(struct reloc_info_sparc *)malloc(fhead.a_trsize))==NULL)exit(1);
	if((drrel=(struct reloc_info_sparc *)malloc(fhead.a_drsize))==NULL)exit(1);
	if((sym=(struct nlist *)malloc(fhead.a_syms))==NULL)exit(1);
	printf("strsize= %d\n",sbuf.st_size-N_STROFF(fhead));
	if((str=malloc(sbuf.st_size-N_STROFF(fhead)))==NULL)exit(1);
	lseek(fd,N_DRELOFF(fhead),0);
	read(fd,drrel,fhead.a_drsize);
	printf("data relocation\n");
	for(i=0;i<fhead.a_drsize/sizeof(struct reloc_info_sparc);i++,drrel++)
		printf("%8x %8x %1d %2d %8x\n",drrel->r_address,drrel->r_index,
			drrel->r_extern,drrel->r_type,drrel->r_addend);
	lseek(fd,N_TRELOFF(fhead),0);
	read(fd,trrel,fhead.a_trsize);
	printf("text relocation\n");
	for(i=0;i<fhead.a_trsize/sizeof(struct reloc_info_sparc);i++,trrel++)
		printf("%8x %8x %1d %2d %8x\n",trrel->r_address,trrel->r_index,
			trrel->r_extern,trrel->r_type,trrel->r_addend);
	lseek(fd,N_SYMOFF(fhead),0);
	read(fd,sym,fhead.a_syms);
	lseek(fd,N_STROFF(fhead),0);
	read(fd,str,sbuf.st_size-N_STROFF(fhead));
	printf("symbol table\n");
	for(i=0;i<fhead.a_syms/sizeof(struct nlist);i++,sym++)
		printf("%20s %3d %3d %6d %8x\n",str+sym->n_un.n_strx,sym->n_type,
			sym->n_other,sym->n_desc,sym->n_value);
	close(fd);
}

main(argc,argv)
int argc;
char **argv;
{
	loadcode(argv[1]);
}

