/* %W% %G% */

#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

#include "constdef.h"
#define MAIN
#include "defvar.h"

#define	ALLOC	-1
#define	HEAP	-2
#define	SYM	-3
#define	USAGE	-4
#define	STKSML	-5
#define	STKOPT	-6

int heapsize = 512;		/* default */
int lstacksize=64;
int bstacksize=32;
int cstacksize=64;
int estacksize=16;
int extpercent=90; /* extend heap size if used up > 90 % */

main(ac,av)
int ac;
char **av;
{
  register char *cp;
  argv = av;
  argc = ac;
  
  av++;
  while(--ac > 0){
    cp = av++[0];
    if(cp[0] == '-'){
      switch(cp[1]){
      case 'h':
	if ((--ac <= 0) || (heapsize = atoi(av++[0])) == 0)
	  errmsg(USAGE);
	break;
      case 'p':
	if ((--ac <= 0) || (extpercent = atoi(av++[0])) == 0)
	  errmsg(USAGE);
	break;
      case 's':
	errmsg(STKOPT);
	break;
      case 'l':
	if(cp[2]!='s')break;
	if ((--ac <= 0) || (lstacksize = atoi(av++[0])) == 0)
	  errmsg(USAGE);
	break;
      case 'c':
	if(cp[2]!='s')break;
	if ((--ac <= 0) || (cstacksize = atoi(av++[0])) == 0)
	  errmsg(USAGE);
	break;
      case 'b':
	if(cp[2]!='s')break;
	if ((--ac <= 0) || (bstacksize = atoi(av++[0])) == 0)
	  errmsg(USAGE);
	break;
      case 'e':
	if(cp[2]!='s')break;
	if ((--ac <= 0) || (estacksize = atoi(av++[0])) == 0)
	  errmsg(USAGE);
	break;
      case 'n':
	break;
      case 'F':
	break;
      default:
	break;
      }
    }
  }
  heapsize *= 1024;
  lstacksize *= 1024;
  bstacksize *= 1024;
  cstacksize *= 1024;
  estacksize *= 1024;
  if((lstacktop = (WORD *)malloc(lstacksize)) == 0) errmsg(ALLOC);
  lstack=lstackbottom=lstacktop+lstacksize/sizeof(WORD);
  if((bstacktop = (WORD *)malloc(bstacksize)) == 0) errmsg(ALLOC);
  bstack=bstackbottom=bstacktop+bstacksize/sizeof(WORD);
  if((cstacktop = (WORD *)malloc(cstacksize)) == 0) errmsg(ALLOC);
  cstack=cstackbottom=cstacktop+cstacksize/sizeof(WORD);
  if((estacktop = (struct lispenv *)malloc(estacksize)) == 0) errmsg(ALLOC);
  estack=estackbottom=estacktop+estacksize/sizeof(struct lispenv);
  if((allheaptop=(WORD *)malloc(heapsize*2))==NULL)errmsg(ALLOC);
  allheapbottom=allheaptop+heapsize/sizeof(int)*2;
  heaptop=heap=allheaptop;
  heapbottom=heaptop+heapsize/sizeof(int);
  setup();
}

errmsg(id)
{
  switch(id){
  case USAGE:
    fprintf(stderr,"Usage: %s [-h size] [-S size] [-f size] [-F fname]\n",argv[0]);
    fprintf(stderr,"          [-cs size][-ls size][-bs size][-es size][-n]\n");
    exit(1);
  case HEAP:
    fprintf(stderr,"%s: Too small heap area.\n",argv[0]);
    exit(1);
  case SYM:
    fprintf(stderr,"%s: Too small symbol area.\n",argv[0]);
    exit(1);
  case ALLOC:
    fprintf(stderr,"%s: Heap allocation failed.\n",argv[0]);
    exit(1);
  case STKSML:
    fprintf(stderr,"%s: Too small stack size.\n",argv[0]);
    exit(1);
  case STKOPT:
    /*	fprintf(stderr,"%s%s\n","Caution! stacksize is defined",
	" by limit command. (ignored)");*/
    break;
  default:
    exit(1);
  }
}
