/* %W% %D% */

#include "constdef.h"
#include "defvar.h"

#define bin32 (256.0*256.0*256.0*256.0)
WORD flzerop_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval;
  
  if(na!=1)parerr();
  fval=floval(checkflo(a,*fp));
  if(fval==0.0)return(true);
  return(nil);
}

WORD flplusp_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval;
  
  if(na!=1)parerr();
  fval=floval(checkflo(a, *fp));
  if(fval>0.0)return(true);
  return(nil);
}
WORD flminsp_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval;
  
  if(na!=1)parerr();
  fval=floval(checkflo(a, *fp));
  if(fval<0.0)return(true);
  return(nil);
}

WORD floeq_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval0,fval1;

  if(na!=2)parerr();
  fval0=floval(checkflo(a,*fp));
  fval1=floval(checkflo(a,*(fp+1)));
  if(fval0==fval1)return(true);
  return(nil);
}

WORD floshrp_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval0,fval1;

  if(na!=2)parerr();
  fval0=floval(checkflo(a,*fp));
  fval1=floval(checkflo(a,*(fp+1)));
  if(fval0!=fval1)return(true);
  return(nil);
}

WORD subflo_f(na,fp)
WORD *fp;
{
  WORD *tmpstack,a,alflonum();
  int i;
  double fval;

  if(na<1)parerr();
  if(na==1)return(alflonum(-floval(checkflo(a,pop())),fp));
  fval=floval(*(tmpstack=fp+na-1));
  for(i=0;i<na-1;i++)
    fval-=floval(checkflo(a,*--tmpstack));
  return(alflonum(fval,fp));
}

WORD addflo_f(na,fp)
WORD *fp;
{
  WORD *tmpstack,a,alflonum();
  double fval=(double)0;

  for(tmpstack=fp+na;na-->0;)
    fval+=floval(checkflo(a,*--tmpstack));
  return(alflonum(fval,fp));
}

WORD mulflo_f(na,fp)
WORD *fp;
{
  WORD *tmpstack,a,alflonum();
  double fval;

  fval=1.0;
  for(tmpstack=fp+na;na-->0;)
    fval*=floval(checkflo(a,*--tmpstack));
  return(alflonum(fval,fp));
}

WORD divflo_f(na,fp)
WORD *fp;
{
  WORD *tmpstack,a,alflonum();
  int i;
  double fval;

  if(na<1)parerr();
  fval=floval(*(tmpstack=fp+na-1));
  for(i=0;i<na-1;i++)
    fval/=floval(checkflo(a,*--tmpstack));
  return(alflonum(fval,fp));
}

WORD modflo_f(na,fp)
WORD *fp;
{
  WORD alflonum(),a;
  double fval0,fval1;

  if(na!=2)parerr();
  fval1=floval(checkflo(a,*fp));
  fval0=floval(checkflo(a,*(fp+1)));
  return(alflonum(fval0-(int)(fval0/fval1)*fval1,fp));
}

WORD a1flo_f(na,fp)
WORD *fp;
{
  WORD alflonum(),a;

  if(na!=1)parerr();
  return(alflonum(floval(checkflo(a,*fp))+1.0,fp));
}

WORD s1flo_f(na,fp)
WORD *fp;
{
  WORD alflonum(),a;

  if(na!=1)parerr();
  return(alflonum(floval(checkflo(a,*fp))-1.0,fp));
}

WORD fix_f(na,fp)
WORD *fp;
{
  WORD a,flotobig();
  double fval;

  if(na!=1)parerr();
  fval=floval(checkflo(a,*fp));
#ifndef NOBIG
  if(fval>(double)MAXFIX || fval<(double)MINFIX)
    return(flotobig(fval,fp));
#endif
  return(itofix((int)fval));
}
#ifndef NOBIG

WORD flotobig(fval,fp)
double fval;
WORD *fp;
{
  int i,sign=0,val,size;
  double fval1;
  WORD new,albignum(),negbig2(),normbig();

  if(fval<0){fval= -fval;sign=1;}
  for(i=1;fval>bin32/2.0;i++)fval/=bin32;
  new=albignum(size=i,fp);
  if(!sign){
    for(;i>0;--i){
      val=bigcodes(new,i-1)=(int)fval;
      fval=(fval-(double)val)*bin32;
    }
  }
  else{
    for(;i>0;--i){
      val=(int)fval;
      bigcodes(new,i-1)= ~val;
      fval=(fval-(double)val)*bin32;
    }
    uadd1(new+BIGCODES,1,size*4);
  }
  return(normbig(new,fp));
}
#endif

WORD float_f(na,fp)
WORD *fp;
{
  WORD a,alflonum();
  double bigtoflo();

  if(na!=1)parerr();
  if(tag(a= *fp)==FIXNUM)return(alflonum((float)fixtoi(a),fp));
  checkbig(a,a);
  return(alflonum(bigtoflo(a,fp),fp));
}

double bigtoflo(a,fp)
WORD a;
{
  int len,i,val,sbit=1;
  double fval=0.0;

  len=fixtoi(osize(a));
  if((int)bigcodes(a,len-1)<0){
    while(len-->0)fval=fval*bin32+(double)(0xffffffff-bigcodes(a,len));
    return(-fval);
  }
  else{
    while(len-->0)fval=fval*bin32+(double)(bigcodes(a,len));
    return(fval);
  }
}

WORD grflo_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval0,fval1;

  if(na<1)parerr();
  fval0=floval(checkflo(a,pop()));
  while(--na>0){
    fval1=floval(checkflo(a,pop()));
    if(fval1<=fval0){
      return(nil);
    }
    fval0=fval1;
  }
  return(true);
}

WORD geflo_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval0,fval1;

  if(na<1)parerr();
  fval0=floval(checkflo(a,pop()));
  while(--na>0){
    fval1=floval(checkflo(a,pop()));
    if(fval1<fval0){
      return(nil);
    }
    fval0=fval1;
  }
  return(true);
}

WORD ltflo_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval0,fval1;

  if(na<1)parerr();
  fval0=floval(checkflo(a,pop()));
  while(--na>0){
    fval1=floval(checkflo(a,pop()));
    if(fval1>=fval0){
      return(nil);
    }
    fval0=fval1;
  }
  return(true);
}

WORD leflo_f(na,fp)
WORD *fp;
{
  WORD a;
  double fval0,fval1;

  if(na<1)parerr();
  fval0=floval(checkflo(a,pop()));
  while(--na>0){
    fval1=floval(checkflo(a,pop()));
    if(fval1>fval0){
      return(nil);
    }
    fval0=fval1;
  }
  return(true);
}
