/* %W% %D% */

#include "constdef.h"
#include "defvar.h"

WORD atom_f(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tag(ag(0))==CONS)return(nil);
  return(true);
}

WORD numberp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(!((int)(a=ag(0))&3))return(true);
  else if(tag(a)!=OTHERS)return(nil);
  else if(otag(a)==BIGNUM)return(true);
  else if(otag(a)==FLONUM)return(true);
  return(nil);
}

WORD stringp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=STRING)return(nil);
  return(true);
}

WORD vectorp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=VECTOR)return(nil);
  return(true);
}

WORD integerp_f(na,fp)
WORD *fp;
{
  WORD a;
  int t;

  if(na!=1)parerr();
  if((t=tag(a=ag(0)))==FIXNUM)return(true);
  else if(t!=OTHERS || otag(a)!=BIGNUM)return(nil);
  return(true);
}
WORD floatp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=FLONUM)return(nil);
  return(true);
}
WORD bigp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=BIGNUM)return(nil);
  return(true);
}

WORD streamp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=STREAM)return(nil);
  return(true);
}

WORD string_streamp_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=STREAM|| !(mode(a)&STRINGSTREAM))return(nil);
  return(true);
}

WORD referencep_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || tag3(otag(a))==OTAGS)return(nil);
  return(true);
}
WORD codep_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  if(tag(a=ag(0))!=OTHERS || otag(a)!=CODE)return(nil);
  return(true);
}

WORD fixp_f(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tag(ag(0))!=FIXNUM)return(nil);
  return(true);
}

WORD symbolp_f(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tag(ag(0))!=SYMBOL)return(nil);
  return(true);
}

WORD consp_f(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(tag(ag(0))!=CONS)return(nil);
  return(true);
}

WORD predef_f(na,fp) /* $@$3$N4X?t$O%^%K%e%"%k$K$O:\$C$F$$$J$$$N$GL5;k$9$k(J */
WORD *fp;
{
  udferr(nil,fp);
  return(nil); 
}

WORD eq_f(na,fp)
WORD *fp;
{
  if(na!=2)parerr();
  if(ag(0)!=ag(1))return(nil);
  return(true);
}

WORD neq_f(na,fp)
WORD *fp;
{
  if(na!=2)parerr();
  if(ag(0)==ag(1))return(nil);
  return(true);
}

WORD equal_f(na,fp)
WORD *fp;
{
  if(na!=2)parerr();
  if(equal(ag(0),ag(1)))return(true);
  return(nil);
}

WORD null_f(na,fp)
WORD *fp;
{
  if(na!=1)parerr();
  if(ag(0)!=nil)return(nil);
  return(true);
}

equal(a,b)
WORD a,b;
{
  int i,len;
  switch(tag(a)){
  case FIXNUM:
  case SYMBOL:
    if(a==b)return(1);
    return(0);
  case OTHERS:
    switch(otag(a)){
    case BIGNUM:
      if(osize(a)!=osize(b))return(0);
      for(i=0,len=fixtoi(osize(a));i<len;i++)
	if(bigcodes(a,i)!=bigcodes(b,i))return(0);
      return(1);
    case FLONUM:
      if(floval(a)==floval(b))return(1);
      return(0);
    case VECTOR:
      if(osize(a)!=osize(b))return(0);
      for(i=0,len=fixtoi(osize(a));i<len;i++)
	if(vecelm(a,i)!=vecelm(b,i))return(0);
      return(1);
    case STRING:
      if(osize(a)!=osize(b))return(0);
      for(i=0,len=fixtoi(osize(a));i<len;i++)
	if(*(stringcodes(a)+i)!= *(stringcodes(b)+i))return(0);
      return(1);
    default:
      if(a==b)return(1);
      return(0);
    }
  case CONS:
    if((tag(b)==CONS)&&equal(car(a),car(b))&&equal(cdr(a),cdr(b)))
      return(1);
  }
}
    
WORD predefinedp_f(na,fp)
WORD *fp;
{
  WORD sym,def;

  if(na!=1)parerr();
  checksym(sym,ag(0));
  if((def=definition(sym))==(WORD)uderr)return(nil);
  if(tag(def)==OTHERS)return(true);
  return(nil);
}
