/* %W% %D% */

#include <stdio.h>
#include "constdef.h"
#include "defvar.h"

/* gc $@$N$?$a$N>pJs$O(Jpush$@$7$F$"$k!#(J */
WORD and_e(a,fp)
WORD a,*fp;
{
  WORD rval,eval();

  l(0)=a;
  for(rval=true;tag(a)==CONS;a=l(0)=cdr(l(0)))
    if((rval=eval(car(a),fp-1))==nil)break;
  return(rval);
}

WORD or_e(a,fp)
WORD a,*fp;
{
  WORD rval,eval();

  l(0)=a;
  for(rval=nil;tag(a)==CONS;a=l(0)=cdr(l(0)))
    if((rval=eval(car(a),fp-1))!=nil)break;
  return(rval);
}

WORD cond_e(a,fp)
WORD a,*fp;
{
  WORD rval,d;

  l(0)=a;
  for(;tag(a)==CONS;a=l(0)=cdr(l(0))){
    checkcons(d,car(a));
    if((rval=eval(car(d),fp-1))!=nil){
      l(0)=a=cdr(car(l(0)));
      for(;tag(a)==CONS;a=l(0)=cdr(l(0)))
	rval=eval(car(a),fp-1);
      return(rval);
    }
  }
  return(nil);
}

WORD selectq_e(a,fp)
WORD a;
{
  WORD key,pattern,consequent,progn_e(),b;

  if(tag(a)!=CONS)parerr();
  key=eval(car(a),fp);
  for(a=cdr(a);tag(a)==CONS;a=cdr(a)){
    if(tag(b=car(a))!=CONS)parerr();
    if(tag(pattern=car(b))==CONS){
      for(;tag(pattern)==CONS;pattern=cdr(pattern))
	if(car(pattern)==key)
	  return(progn_e(cdr(car(a)),fp));
      continue;
    }
    else if(pattern==true)
      return(progn_e(cdr(car(a)),fp));
    else if(pattern==key)
      return(progn_e(cdr(car(a)),fp));
  }
  return(nil);
}

WORD prog_e(a,fp)
WORD a,*fp;
{
  WORD *tmpbstack,*tmpcstack,val,rval,body,sym;
  WORD *orgstack,arglist,alcons(),*sp;
  int args=0,t;
  jmp_buf env,*tmpenv;

  orgstack=bstack;
  l(2)=a;
  for(l(1)=arglist=car(a);tag(arglist)==CONS;arglist=l(1)=cdr(l(1)),args++){
    if(tag(sym=car(arglist))!=CONS){
      pushb(sym);pushb(value(sym));value(sym)=nil;
    }
    else{
      for(l(3)=sym,val=nil,l(0)=body=cdr(car(arglist));tag(body)==CONS;body=l(0)=cdr(l(0)))
	val=eval(car(body),fp-4);
      pushb(sym=car(l(3)));pushb(value(sym));value(sym)=val;
    }
  }
  tmpbstack=bstack;
  tmpcstack=cstack;
  if(setjmp(env)){
    while(bstack<tmpbstack){
      val=popb();
      value(popb())=val;
    }
    cstack=tmpcstack;
    if(progtag==(WORD)0){
      rval=progval;
      goto unbound;
    }
    l(1)=body=progval;
    goto goent;
  }
  else{
    if(--estack<estacktop){
      printf("estack overflow\n");
      exit(1);
    }
    estack->envtag=PROGENV;
    estack->envobj=l(2);
    estack->envbuf=(jmp_buf *)env;
    l(1)=body=cdr(l(2));
  goent:
    for(;tag(body)==CONS;body=l(1)=cdr(l(1)))
      if(tag(car(body))==CONS)
        eval(car(body),fp-3);
    rval=nil;
  unbound:
    estack++;
    while(bstack<orgstack){
      val=popb();
      value(popb())=val;
    }
    return(rval);
  }
}

WORD catch_e(a,fp)
WORD a,*fp;
{
  WORD *tmpbstack=bstack,val,rval,body,mytag;
  WORD *tmpcstack=cstack,*sp;
  jmp_buf env,*tmpenv;

  if(setjmp(env)){
    while(bstack<tmpbstack){
      val=popb();
      value(popb())=val;
    }
    estack++;
    cstack=tmpcstack;
    return(catchval);
  }
  else{
    lstack=fp;
    l(0)=a;
    l(1)=eval(car(a),fp-1);
    if(--estack<estacktop){
      printf("estack overflow\n");
      exit(1);
    }
    estack->envtag=CATCHENV;
    estack->envobj=l(1);
    estack->envbuf=(jmp_buf *)env;
    for(l(0)=body=cdr(l(0));tag(body)==CONS;body=l(0)=cdr(l(0)))
      val=eval(car(body),fp-2);
    estack++;
    return(val);
  }
}

WORD go_e(a,fp)
WORD a,*fp;
{
  struct lispenv *envptr;
  WORD d,w;

  a=car(a);
  for(envptr=estack;envptr<estackbottom;envptr++)
    if(envptr->envtag==PROGENV){
      for(d=envptr->envobj;tag(d)==CONS;d=cdr(d))
	if(tag(w=car(d))!=CONS && w==a){
	  progval=cdr(d);
	  progtag=(WORD)8;
	  estack=envptr;
	  longjmp(envptr->envbuf);
	}
    }
  goerr(a,fp);
}

WORD quote_e(a,fp)
WORD a,*fp;
{
  return(car(a));
}
WORD comment_e(a,fp)
WORD a,*fp;
{
  return(nil);
}

WORD progn_e(a,fp)
WORD a,*fp;
{
  WORD rval=nil;

  for(l(0)=a;tag(a)==CONS;a=l(0)=cdr(l(0))){
    rval=eval(car(a),fp-1);
  }
  return(rval);
}

WORD prog1_e(a,fp)
WORD a,*fp;
{
  l(0)=a;
  if(tag(a)!=CONS)parerr();
  l(1)=eval(car(a),fp-1);
  for(l(0)=a=cdr(l(0));tag(a)==CONS;a=l(0)=cdr(l(0)))
    eval(car(a),fp-2);
  return(l(1));
}

WORD prog2_e(a,fp)
WORD a,*fp;
{
  WORD prog1_e();

  l(0)=a;
  if(tag(a)!=CONS)parerr();
  eval(car(a),fp-1);
  return(prog1_e(cdr(l(0)),fp));
}

WORD push_e(a,fp)
WORD a,*fp;
{
  WORD list,sym,val,eval(),alcons();

  l(0)=car(cdr(a));
  list=alcons(eval(car(a),fp-1),value(l(0)),fp-1);
  return(value(l(0))=list);
}

WORD pop_e(a)
WORD a;
{
  WORD rval,d;

  d=value(car(a));
  rval=car(d);
  value(car(a))=cdr(d);
  return(rval);
}

WORD setq_e(a,fp)
WORD a,*fp;
{
  WORD val,rval,eval(),*sp;
  int na;

  for(rval=nil,na=0,l(0)=a,sp=fp-1;tag(a)==CONS;a=l(0)=cdr(cdr(l(0))),na++,sp-=2){
    *(sp-1)=car(a);
    *(sp-2)=rval=eval(car(cdr(a)),sp-1); /* changed by tan 1988/11/28 */
  }
  for(;na-->0;sp+=2){
    val= *sp;
    value(*(sp+1))=val;
  }
  return(rval);
}

WORD loop_e(a,fp)
WORD a,*fp;
{
  WORD *tmpbstack=bstack,val,rval,body;
  WORD *tmpcstack=cstack,*sp;
  jmp_buf env,*tmpenv;
  
  if(setjmp(env)){
    while(bstack<tmpbstack){
      val=popb();
      value(popb())=val;
    }
    cstack=tmpcstack;
    estack++;
    return(loopval);
  }
  else{
    if(--estack<estacktop){
      printf("estack overflow\n");
      exit(1);
    }
    estack->envtag=LOOPENV;
    estack->envobj=a; /* changed by tan 1988/11/28 */
    estack->envbuf=(jmp_buf *)env;
    l(0)=a;
    for(;;)
      for(body=l(1)=l(0);tag(body)==CONS;l(1)=body=cdr(l(1)))
	eval(car(body),fp-2);
  }
}

WORD match_e(a,fp)
WORD a,*fp;
{
  WORD rval,key,pattern,consequent,*tmpbstack,progn_e();

  l(0)=a;
  key=eval(car(a),fp-1);
  tmpbstack=bstack;
  for(a=cdr(l(0));tag(a)==CONS;a=l(0)=cdr(l(0)))
    if(match(car(car(a)),key)){
      rval=progn_e(cdr(car(a)),fp-1);
      unbind(tmpbstack);
      return(rval);
    }
    else
      unbind(tmpbstack);
  return(nil);
}

unbind(tmpstack)
WORD *tmpstack;
{
  WORD val;

  while(bstack<tmpstack){
    val=popb();
    value(popb())=val;
  }
}
      
match(pattern,key)
WORD pattern,key;
{
  int t;

  if(pattern==nil){
    if(key==nil)
      return(1);
    else
      return(0);
  }
  else if((t=tag(pattern))==SYMBOL){
    bind(pattern,key);
    return(1);
  }
  else if(t!=CONS){
    if(pattern==key)return(1);
  }
  else if(car(pattern)==quote){
    if(car(cdr(pattern))==key)
      return(1);
  }
  else if(tag(key)==CONS && match(car(pattern),car(key)) &&
	  match(cdr(pattern),cdr(key)))
    return(1);
  return(0);
}

/* from sysfneval.c */

WORD let_e(a,fp)
WORD a,*fp;
{
  WORD arglist,body,val,rval,eval(),*sp,*bs;
  int args=0,t;

  enter(2);
  l(0)=a;
  for(l(1)=arglist=car(a);tag(arglist)==CONS;arglist=l(1)=cdr(l(1)),args++){
    *(sp-1)=car(car(arglist));
    body=cdr(car(arglist));
    if(tag(body)==CONS){
      rval=eval(car(body),sp-1);
      if(tag(cdr(body))==CONS)parerr();
    }
    else parerr();
    sp-=2;
    *sp=rval;
  }
  for(t=0,sp=fp-2,bs=bstack;t<args;t++,sp-=2,bs-=2){
    *(bs-1)= *(sp-1);
    *(bs-2)=value(*(sp-1));
    value(*(sp-1))= *(sp-2);
  }
  bstack=bs;
  for(l(0)=body=cdr(l(0));tag(body)==CONS;body=l(0)=cdr(l(0)))
    rval=eval(car(body),fp-1);
  for(t=0;t<args;t++){
    val=popb();
    value(popb())=val;
  }
  return(rval);
}

WORD lets_e(a,fp)
WORD a,*fp;
{
  WORD arglist,body,rval,val,eval(),*sp;
  int args=0,t;

  l(0)=a;
  for(l(1)=arglist=car(a);tag(arglist)==CONS;arglist=l(1)=cdr(l(1)),args++){
    pushb(l(2)=car(car(arglist)));
    pushb(value(l(2)));
    for(l(3)=body=cdr(car(arglist)),val=nil;tag(body)==CONS;body=l(3)=cdr(l(3)))
      val=eval(car(body),fp-4);
    value(l(2))=val;
  }
  for(l(1)=body=cdr(l(0));tag(body)==CONS;body=l(1)=cdr(l(1)))
    rval=eval(car(body),fp-2);
  for(t=0;t<args;t++){
    val=popb();
    value(popb())=val;
  }
  return(rval);
}

exit_f(na,fp)
WORD *fp;
{
  struct lispenv *envptr;

  if(na==0)loopval=nil;
  else loopval=ag(0);
  for(envptr=estack;envptr<estackbottom;envptr++)
    if(envptr->envtag==LOOPENV){
      estack=envptr;
      longjmp(envptr->envbuf);
    }
  reterr(loopval,fp);
}

return_f(na,fp)
WORD *fp;
{
  struct lispenv *envptr;

  if(na==0)progval=nil;
  else progval=ag(0);
  for(envptr=estack;envptr<estackbottom;envptr++)
    if(envptr->envtag==PROGENV){
      progtag=(WORD)0;
      estack=envptr;
      longjmp(envptr->envbuf);
    }
  reterr(progval,fp);
}

throw_f(na,fp)
WORD *fp;
{
  struct lispenv *envptr;
  WORD a;

  if(na==0)parerr();
  a=ag(na-1);
  if(na>=2)catchval=ag(0);
  else catchval=nil;
  for(envptr=estack;envptr<estackbottom;envptr++)
    if(envptr->envtag==CATCHENV && envptr->envobj==a){
      estack=envptr;
      longjmp(envptr->envbuf);
    }
  ctcherr(a,fp);
}
