/* %W% %D% */

#include "constdef.h"
#include "defvar.h"

WORD character_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  return(checkchar(a,ag(0)));
}

WORD string_f(na,fp)
WORD *fp;
{
  WORD a,alstring();
  int t;
  unsigned char buf[2];

  if(na!=1)parerr();
  if((t=tag(a=ag(0)))==SYMBOL)
    return(prname(a));
  else if(t==FIXNUM && 0<=fixtoi(a) && fixtoi(a)<=255){
    buf[0]=fixtoi(a);
    buf[1]=0;
    return(alstring(buf,fp));
  }
  else if(t==OTHERS && otag(a)==STRING)
    return(a);
  else
    nosymerr(a);
}

WORD string_length_f(na,fp)
WORD *fp;
{
  WORD a;

  if(na!=1)parerr();
  checkstr(a,ag(0));
  return(osize(a));
}

WORD string_lessp_f(na,fp)
WORD *fp;
{
  WORD a,b;

  if(na!=2)parerr();
  checkstr(a,ag(0));
  checkstr(b,ag(1));
  if(strcmp(stringcodes(a),stringcodes(b))>0)return(true);
  return(nil);
}

WORD substring_f(na,fp)
WORD *fp;
{
  WORD a,alstring(),alnstring();
  int start=0,end= -1;
  unsigned char buf[256];

  switch(na){
  case 3:
    end=fixtoi(checkfix(a,pop()));
  case 2:
    start=fixtoi(checkfix(a,pop()));
  case 1:
    checkstr(a,pop());
    if(start<0)inderr(itofix(start),fp);
    if(end<0)end=fixtoi(osize(a));
    else if(end>fixtoi(osize(a)))inderr(itofix(end),fp);
    if(end<start)inderr(itofix(end),fp);
    return(alnstring(stringcodes(a)+start,end-start,fp));
  defalut:
    parerr();
  }
}

WORD string_append_f(na,fp)
WORD *fp;
{
  WORD *tmpstack=fp+na,a,rval,alnstring();
  int i,len;
  unsigned char *str;

  for(i=0,len=0;i<na;i++){
    checkstr(a,*--tmpstack);
    len+=fixtoi(osize(a));
  }
  rval=alnstring("",len,fp);
  tmpstack=fp+na;
  for(i=0,str=stringcodes(rval);i<na;i++,str+=len){
    len=fixtoi(osize(checkstr(a,*--tmpstack)));
    bcopy(stringcodes(a),str,len);
  }
  return(rval);
}

WORD string_reverse_f(na,fp)
WORD *fp;
{
  WORD a,b,alnstring();
  int i,len;
  unsigned char *str;

  if(na!=1)parerr();
  checkstr(a,ag(0));
  b=alnstring("",len=fixtoi(osize(a)),fp);
  for(i=0;i<len;i++)
    *(stringcodes(b)+len-i-1)= *(stringcodes(a)+i);
  return(b);
}

WORD string_nreverse_f(na,fp)
WORD *fp;
{
  int i,j,len,tmp;
  unsigned char *str;
  WORD a;

  if(na!=1)parerr();
  checkstr(a,ag(0));
  str=stringcodes(a);
  len=fixtoi(osize(a));
  for(i=0,j=len-1;i<j;i++,j--){
    tmp=str[i];
    str[i]= str[j];
    str[j]= tmp;
  }
  return(a);
}

WORD string_search_char_f(na,fp)
WORD *fp;
{
  int from=0,minindex,index,end;
  unsigned char ch,*ptr;
  WORD str,a,c;

  switch(na){
  case 3:
    from=fixtoi(checkfix(a,pop()));
  case 2:
    ptr=stringcodes(checkstr(str,pop()));
    end=fixtoi(osize(str))-1;
    if(tag(c=pop())==CONS){
      for(minindex= 1000000;tag(c)==CONS;c=cdr(c)){
	ch=fixtoi(checkchar(a,car(c)));
	if((index=string_search_char(ptr,ch,from,end))>=0 && index<minindex)
	  minindex=index;
      }
    }
    else{
      ch=fixtoi(checkchar(c,c));
      minindex=string_search_char(ptr,ch,from,end);
    }
    break;
  default:
    parerr();
  }
  if(minindex<0)return(nil);
  return(itofix(minindex));
}

string_search_char(str,c,from,end)
unsigned char *str;
{
  int i;

  for(str+=i=from;i<=end;i++)
    if(*str++ ==c)return(i);
  return(-1);
}

WORD string_search_not_char_f(na,fp)
WORD *fp;
{
  int from=0,mindex,index,end;
  unsigned char ch,*ptr;
  WORD str,a,c;

  switch(na){
  case 3:
    checkfix(a,pop());
    from=fixtoi(a);
  case 2:
    checkstr(str,pop());
    ptr=stringcodes(str);
    end=fixtoi(osize(str))-1;
    if(tag(c=pop())==CONS){
      for(mindex= -1;tag(c)==CONS;c=cdr(c)){
	ch=fixtoi(checkchar(a,car(c)));
	if((index=string_search_not_char(ptr,ch,from,end))>mindex)
	  mindex=index;
      }
    }
    else{
      ch=fixtoi(checkchar(c,c));
      mindex=string_search_not_char(ptr,ch,from,end);
    }
    break;
  default:
    parerr();
  }
  if(mindex<0)return(nil);
  return(itofix(mindex));
}

string_search_not_char(str,c,from,end)
unsigned char *str;
{
  int i;

  for(str+=i=from;i<end;i++)
    if(*str++ ==c)return(i);
  return(-1);
}

WORD string_search_f(na,fp)
WORD *fp;
{
  int from=0,index,len,end;
  unsigned char *src,*dst;
  WORD str,a,c;

  switch(na){
  case 3:
    from=fixtoi(checkfix(a,pop()));
  case 2:
    checkstr(str,pop());
    dst=stringcodes(str);
    end=fixtoi(osize(str));
    checkstr(str,pop());
    src=stringcodes(str);
    len=fixtoi(osize(str));
    for(dst+=from;from+len<=end;from++,dst++)
      if(!bcmp(src,dst,len))
	return(itofix(from));
    return(nil);
  default:
    parerr();
  }
}

WORD getchar_f(na,fp)
WORD *fp;
{
  int index;
  WORD a,str,intern(),alnstring();

  if(na!=2)parerr();
  index=fixtoi(checkfix(a,ag(0)));
  checkstr(a,ag(1));
  return(intern(stringcodes(a)+index,1,fp));
}

WORD sref_f(na,fp)
WORD *fp;
{
  WORD string,index;

  if(na!=2)parerr();
  checkfix(index,ag(0));
  checkstr(string,ag(1));
  if((int)index>=(int)osize(string))inderr(index,fp);
  return(itofix(*(stringcodes(string)+fixtoi(index))));
}

WORD sset_f(na,fp)
WORD *fp;
{
  WORD string,index,character;

  if(na!=3)parerr();
  checkchar(character,ag(0));
  checkfix(index,ag(1));
  checkstr(string,ag(2));
  if((int)index>=(int)osize(string))inderr(index,fp);
  return(itofix(*(stringcodes(string)+fixtoi(index))=fixtoi(character)));
}

WORD string_equal_f(na,fp)
WORD *fp;
{
  WORD a,b;
  int len;

  if(na!=2)parerr();
  checkstr(a,ag(0));
  checkstr(b,ag(1));
  if((len=fixtoi(osize(a)))!=fixtoi(osize(b)))return(nil);
  if(bcmp(stringcodes(a),stringcodes(b),len))return(nil);
  return(true);
}

WORD cutout_f(na,fp)
WORD *fp;
{
  WORD len,pos,str;
  int ll,val;
  unsigned char *p;

  if(na!=3)parerr();
  checkfix(len,ag(0));
  checkfix(pos,ag(1));
  checkstr(str,ag(2));
  if((ll=fixtoi(len))>3||ll<0)value(len)=0;
  for(val=0,p=stringcodes(str)+fixtoi(pos);ll>0;ll--)
    val=((val<<8)| *p++);
  return(itofix(val));
}

WORD spread_f(na,fp)
WORD *fp;
{
  WORD len,val,str,alnstring();
  int ll,v;
  unsigned char *p;

  if(na!=2)parerr();
  checkfix(len,ag(0));
  checkfix(val,ag(1));
  if((ll=fixtoi(len))>3||len<0)value(len)=0;
  str=alnstring("",ll,fp);
  for(v=fixtoi(val),p=stringcodes(str)+ll-1;ll>0;ll--,p--,v>>=8)
    *p=v;
  return(str);
}

WORD translate_f(na,fp)
WORD *fp;
{
  WORD tab,str;
  unsigned char *tabp,*strp;
  int len;

  if(na!=2)parerr();
  checkstr(tab,ag(0));
  checkstr(str,ag(1));
  if(osize(tab)!=itofix(256))value(tab)=0;
  tabp=stringcodes(tab);
  strp=stringcodes(str);
  len=fixtoi(osize(str));
  for(;len-->0;strp++)
    *strp= tabp[*strp];
  return(str);
}

WORD string_amend_f(na,fp)
WORD *fp;
{
  int from=0,len;
  WORD a,src,dst;

  switch(na){
  case 3:
    from=fixtoi(checkfix(a,pop()));
  case 2:
    src=checkstr(src,pop());
    dst=checkstr(dst,pop());
    if((len=fixtoi(osize(src)))+from>fixtoi(osize(dst)))value(src)=0;
    bcopy(stringcodes(src),stringcodes(dst)+from,len);
    return(dst);
  default:
    parerr();
  }
}

bcopy_or(from,to,size)
unsigned char *from,*to;
{
  while(size-->0)
    *to++|= *from++;
}

WORD string_amend_or_f(na,fp)
WORD *fp;
{
  int from=0,len;
  WORD a,src,dst;

  switch(na){
  case 3:
    from=fixtoi(checkfix(a,pop()));
  case 2:
    src=checkstr(src,pop());
    dst=checkstr(dst,pop());
    if((len=fixtoi(osize(src)))+from>fixtoi(osize(dst)))value(src)=0;
    bcopy_or(stringcodes(src),stringcodes(dst)+from,len);
    return(dst);
  default:
    parerr();
  }
}

bcopy_xor(from,to,size)
unsigned char *from,*to;
{
  while(size-->0)
    *to++^= *from++;
}

WORD string_amend_xor_f(na,fp)
WORD *fp;
{
  int from=0,len;
  WORD a,src,dst;

  switch(na){
  case 3:
    from=fixtoi(checkfix(a,pop()));
  case 2:
    src=checkstr(src,pop());
    dst=checkstr(dst,pop());
    if((len=fixtoi(osize(src)))+from>fixtoi(osize(dst)))value(src)=0;
    bcopy_xor(stringcodes(src),stringcodes(dst)+from,len);
    return(dst);
  default:
    parerr();
  }
}

bcopy_and(from,to,size)
unsigned char *from,*to;
{
  while(size-->0)
    *to++&= *from++;
}

WORD string_amend_and_f(na,fp)
WORD *fp;
{
  int from=0,len;
  WORD a,src,dst;

  switch(na){
  case 3:
    from=fixtoi(checkfix(a,pop()));
  case 2:
    src=checkstr(src,pop());
    dst=checkstr(dst,pop());
    if((len=fixtoi(osize(src)))+from>fixtoi(osize(dst)))value(src)=0;
    bcopy_and(stringcodes(src),stringcodes(dst)+from,len);
    return(dst);
  default:
    parerr();
  }
}
WORD make_string_f(na,fp)
WORD *fp;
{
  int ch=0,i,ll;
  WORD c,len,ptr;
  WORD p;

  switch(na){
  case 2:
    ch=fixtoi(checkchar(c,pop()));
  case 1:
    ptr=alnstring("",ll=fixtoi(checkfix(len,pop())),fp);
    for(p=stringcodes(ptr);ll-->0;)*p++ =ch;
    break;
  default:
    parerr();
  }
  return(ptr);
}

WORD bset_f(na,fp)
WORD *fp;
{
  WORD index,string,c;
  int ind,bitind;
  unsigned char *str;

  if(na!=3)parerr();
  c=ag(0);
  ind=fixtoi(checkfix(index,ag(1)));
  str=stringcodes(checkstr(string,ag(2)));
  if(ind>=fixtoi(osize(string))*8)inderr(itofix(ind),fp);
  if(c==nil)*(str+(ind/8))&=~(0x80>>(ind&7));
  else *(str+(ind/8))|=(0x80>>(ind&7));
  return(c);
}

WORD bref_f(na,fp)
WORD *fp;
{
  WORD index,string;
  int ind,bitind,mask;
  unsigned char *str;

  if(na!=2)parerr();
  ind=fixtoi(checkfix(index,ag(0)));
  str=stringcodes(checkstr(string,ag(1)));
  if(ind>=fixtoi(osize(string))*8)inderr(itofix(ind),fp);
  if(*(str+(ind/8))&(0x80>>(ind&7)))return(true);
  return(nil);
}

WORD string_match_f(na,fp)
WORD *fp;
{
  WORD a;
  unsigned char *str,*exp;

  if(na!=2)parerr();
  str=stringcodes(checkstr(a,ag(0)));
  exp=stringcodes(checkstr(a,ag(1)));
  if(strmatch(exp,str))return(true);
  return(nil);
}

strmatch(exp,str)
unsigned char *exp,*str;
{
  int i;

  switch(*exp){
  case 0:
    if(*str==0)return(1);
    return(0);
  case '*':
    for(i=0;i<=strlen(str);i++)
      if(strmatch(exp+1,str+i))return(1);
    return(0);
  case '?':
    return(strmatch(exp+1,str+1));
  default:
    if(*exp== *str)return(strmatch(exp+1,str+1));
    return(0);
  }
}


