(defun var? (x)
	(and (symbolp x) (eq (character x) (character "*"))))
(defun anon?(x)
        (and (symbolp x) (eq (character x) (character "_"))))

(defun assigned? (x s_list) (assoc x s_list))

(defun defrule (s)
	(lets ((rules (get (caar s) 'ruleset)))
        (cond ((null rules) (putprop (caar s) `(,s) 'ruleset))
	      (t (nconc rules `(,s))))))

(defun replace (rhs s_list)
  (lets ((x nil) (w nil))
     (cond 
	   ((equal s_list nil) rhs)
           (t (setq w (subst (cadar s_list) (caar s_list) rhs))
              (cond ((null (setq x (cdr s_list))) w)
		    (t (replace w x)))))))	

(defun trs nil
       (lets ((prompt "?|-") (iterm nil) (x nil) (y nil) (z nil))  
	(loop 
	      (setq iterm (read))
	      (cond ((equal (setq x (car iterm)) 'exit) (exit))
	 	    ((equal x 'assert)
			 (defrule  (cadr iterm)))
		    ((equal x 'consult)
		     (setq y (inopen (stream (cadr iterm))))
		     (loop (cond ((setq z (read y)) (print z) (defrule z))
			         (t (close y) (exit)))))
		    (t (print (reduce iterm))))))) 

(defun reduce (iterm)
     (loop
       (lets ((y nil))
	(cond ((car (setq y (rewrite iterm)))
               (setq iterm (cadr y)))
              (t (exit (cadr y)))))))

(defun rewrite (term)
 (cond ((null term) `(nil ,term))
       ((atom term) `(nil ,term))
       ((symbolp term) `(nil ,term))
       (t
        (lets ((rules (get (car term) 'ruleset)))
	 (cond ((listp term)
          (loop
	    (lets ((x nil) (s_list (copy `(nil))))
             (cond ((null rules) 
	             (cond ((rewrite_cdr (cdr term))
			    (exit `(after ,term)))
                           (t (exit `(nil ,term)))))
	            (t 
                       (cond ((match? term (car (setq x (car rules))) s_list)
		       (exit `(before ,(replace (cadr x) (cdr s_list)))))
			     (t     (setq rules (cdr rules)))))))))
	        (t `(nil ,term)))))))

(defun rewrite_cdr (terms)
 (lets ((z nil)(x nil))
            (cond ((equal (car (setq z (rewrite (car terms)))) 'before)
                   (rplaca terms (cadr z)) t)
		  ((equal (car z) 'after) t)
	          (t (cond ((null (setq x (cdr terms))) nil)
		           (t (rewrite_cdr x)))))))

(defun match? (term lhs sub_list)
       (lets ((value nil))
        (cond ((listp lhs)
	   (cond ((listp term) 
		 (cond ((not (equal (length term) (length lhs))) nil)
		       (t (cond ((equal (car term) (car lhs))
                           (match_cdr (cdr term) (cdr lhs) sub_list))
		                (t nil)))))
		 (t nil)))
	      (t (cond ((anon? lhs) t)
	               ((var? lhs) 
		   (cond ((setq value (assigned? lhs (cdr sub_list)))
				 (equal (cadr value) term)) 
			 (t  (nconc sub_list `((,lhs ,term))) t)))
	               (t (equal term lhs)))))))
			         
(defun match_cdr (terms patterns sublist)
  (cond ((null patterns) nil)
        (t (and (listp terms) (listp patterns)
         (cond ((null (match? (car terms) (car patterns) sublist)) nil)
               (t
  (cond ((null (cdr terms)) t)
	(t (cond ((match_cdr (cdr terms) (cdr patterns) sublist) t)
	         (t nil))))))))))
